<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_NORMAL, (!empty($_SESSION['website_id']))?$_SESSION['website_id']:'');

/*=================================================
 Create the manager object, load the libs and class
=================================================*/
require_once $_PX_config['manager_path'].'/inc/class.article.php';

$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

$ar = new Article();
$is_user_admin = authAsLevel(PX_AUTH_ADMIN, $_SESSION['website_id']);
/*=================================================
 Get some info of the current step for the submenu
=================================================*/
// display 'add news' menu?
if (!empty($_REQUEST['op']) || empty($_REQUEST['resource_id'])) $display_add_article = true;
else $display_add_article = false;

$px_submenu->addItem( __('Back to the list of resources'), 'index.php', 'themes/'.$_px_theme.'/images/ico_back.png',	 false);
$px_submenu->addItem( __('Article list'), 'articles.php?op=list', 'themes/'.$_px_theme.'/images/ico_article.png', false);
$px_submenu->addItem( __('New article'),  'articles.php',  'themes/'.$_px_theme.'/images/ico_new.png', false, $display_add_article);


/*==============================================================================
 Process block
==============================================================================*/
/*=================================================
 Set all the default values
=================================================*/
if (!( !empty($_REQUEST['op']) && $_REQUEST['op'] == 'list' )) {
	$px_ar_id                 = '';
	$px_ar_title              = '';
	$px_ar_description        = '';
	$px_ar_description_format = $m->user->getPref('content_format');
	$px_ar_subject            = '';
	$px_ar_status             = ($m->user->getPref('articles_status')) ? $m->user->getPref('articles_status') : PX_RESOURCE_STATUS_INEDITION;
	$px_ar_path               = '';
	$px_ar_noenddate          = 1;
	$px_ar_category_id        = $m->user->getPref('articles_category_id');
	$px_ar_categories         = new recordset();
	$px_ar_authors            = new recordset();
	$px_ar_pages              = new recordset();
	$px_ar_subtype            = $m->user->getPref('articles_subtype');
	// start date
	$px_ar_ts = time();
	$dt_y = date('Y',$px_ar_ts);
	$dt_m = date('m',$px_ar_ts);
	$dt_d = date('d',$px_ar_ts);
	$dt_h = (string) date('H',$px_ar_ts);
	$dt_i = (string) date('i',$px_ar_ts);
	$dt_s = (string) date('s',$px_ar_ts);
	// end date
	$dt_e_y = '9999';
	$dt_e_m = '12';
	$dt_e_d = '31';
	$dt_e_h = '23';
	$dt_e_i = '59';
	$dt_e_s = '59';
	$px_ar_enddate = $dt_e_y.'-'.$dt_e_m.'-'.$dt_e_d.' '.$dt_e_h.':'.$dt_e_i.':'.$dt_e_s;
	$px_ar_pubdate = $dt_y.'-'.$dt_m.'-'.$dt_d.' '.$dt_h.':'.$dt_i.':'.$dt_s;

	$subtypes = $m->getSubTypes('','articles');
	$arry_subtypes = array();
	if ($subtypes->nbRow() == 0) {
		$m->setError(sprintf( __('You need to <a href="%s">add 2 types of resource</a>, one for the articles and one for the news.'), 'subtypes.php?op=add'), 500);
	}
	while (!$subtypes->EOF()) {
		$arry_subtypes[$subtypes->f('subtype_name')] = $subtypes->f('subtype_id');
		$subtypes->moveNext();
	}
}

$px_ar_textarea = $m->user->getPref('article_textarea_description');
$px_ar_page_textarea = $m->user->getPref('article_textarea_page');

/*===============================================================
 Get current article and check if right to edit it
===============================================================*/
$is_editable = true;
if (!empty($_REQUEST['resource_id'])) {
	if ((($ar = $m->getResourceByIdentifier($_REQUEST['resource_id'], 'Article')) !== false)
		&& $ar->f('type_id') == 'articles' && $ar->f('website_id') == $m->user->website) {
		// check the rights
		if ((authAsLevel(PX_USER_LEVEL_ADVANCED, $ar->f('website_id'))
		   || ($ar->f('user_id') == $m->user->user['user_id'] && $ar->f('status') != PX_RESOURCE_STATUS_VALIDE)) ) {
			$is_editable = true;
		} else {
			$is_editable = false;
		}
			// ok for edition
			$px_ar_id                 = $ar->f('resource_id');
			$px_ar_title              = $ar->f('title');
			$px_ar_description        = textGetRawContent($ar->f('description'));
			$px_ar_description_format = (($type = textGetType($ar->f('description'))) !== false) ? $type : $m->user->getPref('content_format');
			$px_ar_subject            = $ar->f('subject');
			$px_ar_status             = $ar->f('status');
			$px_ar_path               = $ar->f('path');
			$px_ar_subtype            = $ar->f('subtype_id');
			$px_ar_categories         = $ar->getCategories();
			$px_ar_authors            = $ar->getAuthors();
			$px_ar_pages              = (false != ($temp = $ar->getPages())) ? $temp : $px_ar_pages;
			list($dt_h,   $dt_i,   $dt_s,   $dt_m,   $dt_d,   $dt_y)   = explodeDate($ar->f('publicationdate'));
			list($dt_e_h, $dt_e_i, $dt_e_s, $dt_e_m, $dt_e_d, $dt_e_y) = explodeDate($ar->f('enddate'));
			$px_ar_noenddate = ($dt_e_y == 9999); /** @todo bug to fix in year 9999 :o) */
	  /*  } else {
			// @TODO: Manage the case where right to view without edit.
			if ($ar !=)
			$is_editable = false;

		} */
	} else {
		$is_editable = false;
		$m->setError( __('Error: The requested article is not available.'), 400);
	}
}

/*===============================================================
 Add/edit an article
===============================================================*/
if (empty($_REQUEST['op'])):


/*=================================================
 Set values from submitted form
=================================================*/
if  ((!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform'])
	|| !empty($_POST['increase']) || !empty($_POST['increase_x']) || !empty($_POST['decrease']) || !empty($_POST['decrease_x']))
	&& $is_editable) {
	$px_ar_title              = $_POST['a_title'];
	$px_ar_description        = $_POST['a_description'];
	$px_ar_description_format = $_POST['a_description_format'];
	$px_ar_subject            = $_POST['a_subject'];
	$px_ar_status             = $_POST['a_status'];
	$px_ar_path               = $_POST['a_path'];
	$px_ar_category_id        = $_POST['a_category_id'];
	$px_ar_noenddate          = (!empty($_POST['a_noenddate']));
	$px_ar_subtype            = $_POST['a_subtype'];

	if (!empty($_POST['increase']) || !empty($_POST['increase_x'])) {
		$px_ar_textarea = $m->user->increase('article_textarea_description');
	}
	if (!empty($_POST['decrease']) || !empty($_POST['decrease_x'])) {
		$px_ar_textarea = $m->user->decrease('article_textarea_description');
	}

	if (!empty($px_ar_id)) {
		$dt_y = (string) sprintf('%04d',$_POST['a_dt_y']);
		$dt_m = (string) sprintf('%02d',$_POST['a_dt_m']);
		$dt_d = (string) sprintf('%02d',$_POST['a_dt_d']);
		$dt_h = (string) sprintf('%02d',$_POST['a_dt_h']);
		$dt_i = (string) sprintf('%02d',$_POST['a_dt_i']);
		$dt_s = (string) sprintf('%02d',$_POST['a_dt_s']);
		# Correct day and time
		if ($dt_d > 31 || $dt_d < 1) { $dt_d = '01'; }
		if ($dt_h > 23 || $dt_h < 0) { $dt_h = '00'; }
		if ($dt_i > 59 || $dt_i < 0) { $dt_i = '00'; }
		if ($dt_s > 59 || $dt_s < 0) { $dt_s = '00'; }

		if (!$px_ar_noenddate) {
			$dt_e_y = (string) sprintf('%04d',$_POST['a_dt_e_y']);
			$dt_e_m = (string) sprintf('%02d',$_POST['a_dt_e_m']);
			$dt_e_d = (string) sprintf('%02d',$_POST['a_dt_e_d']);
			$dt_e_h = (string) sprintf('%02d',$_POST['a_dt_e_h']);
			$dt_e_i = (string) sprintf('%02d',$_POST['a_dt_e_i']);
			$dt_e_s = (string) sprintf('%02d',$_POST['a_dt_e_s']);
			# Correct day and time
			if ($dt_e_d > 31 || $dt_e_d < 1) { $dt_e_d = '01'; }
			if ($dt_e_h > 23 || $dt_e_h < 0) { $dt_e_h = '00'; }
			if ($dt_e_i > 59 || $dt_e_i < 0) { $dt_e_i = '00'; }
			if ($dt_e_s > 59 || $dt_e_s < 0) { $dt_e_s = '00'; }
		} else {
			$dt_e_y = '9999';
			$dt_e_m = '12';
			$dt_e_d = '31';
			$dt_e_h = '23';
			$dt_e_i = '59';
			$dt_e_s = '59';
		}

		$px_ar_enddate = $dt_e_y.'-'.$dt_e_m.'-'.$dt_e_d.' '.$dt_e_h.':'.$dt_e_i.':'.$dt_e_s;
		$px_ar_pubdate = $dt_y.'-'.$dt_m.'-'.$dt_d.' '.$dt_h.':'.$dt_i.':'.$dt_s;
	}

	if (!empty($_POST['transform'])) {
		$px_ar_description = textParseContent("=$px_ar_description_format\n".$px_ar_description);
		$px_ar_description_format = 'html';
	}
}

/*=================================================
 When adding a category
=================================================*/
if (!empty($_REQUEST['a_category_id'])) {
	$px_ar_category_id = $_REQUEST['a_category_id'];
}

/*=================================================
 Add, edit an article - database operations
=================================================*/

if (!empty($_POST['publish']) && $is_editable) {
	if (!empty($px_ar_id)) {
		// edit
		$ar->set($px_ar_title, $px_ar_subject, $px_ar_description, $px_ar_description_format, $px_ar_status,
		         $px_ar_path, $px_ar_pubdate, $px_ar_enddate, !$px_ar_noenddate, $px_ar_subtype);
		if (false !== ($id = $m->updArticle($ar))) {
			if ($px_ar_status != PX_RESOURCE_STATUS_INEDITION) {
				$msg =  __('The article was successfully saved.');
				header('Location: articles.php?op=list&msg='.urlencode($msg));
			} else
				header('Location: articles.php?resource_id='.$id);
			exit;
		}
	} else {
		// new
		$m->user->savePref('articles_category_id', $px_ar_category_id, $_SESSION['website_id']);
		$m->user->savePref('articles_status', $px_ar_status, $_SESSION['website_id']);
		$m->user->savePref('content_format', $px_ar_description_format, $_SESSION['website_id']);
		$m->user->savePref('articles_subtype', $px_ar_subtype, $_SESSION['website_id']);
		$ar->set($px_ar_title, $px_ar_subject, $px_ar_description, $px_ar_description_format, $px_ar_status,
		         $px_ar_path, $px_ar_pubdate, $px_ar_enddate, !$px_ar_noenddate, $px_ar_subtype, $px_ar_category_id, $_SESSION['website_id'], $m->user->user['user_id']);
		if (false !== ($id = $m->addArticle($ar))) {
			if ($px_ar_status != PX_RESOURCE_STATUS_INEDITION) {
				$msg =  __('The article was successfully saved.');
				header('Location: articles.php?op=list');
			} else
				header('Location: articles.php?resource_id='.$id);
			exit;
		}
	}
}

if (!empty($_REQUEST['addcategory']) && !empty($px_ar_id) && $is_editable) {
	$m->user->savePref('articles_category_id', $px_ar_category_id, $_SESSION['website_id']);
	$type = ('main' == $_REQUEST['addcategory']) ? PX_RESOURCE_CATEGORY_MAIN : PX_RESOURCE_CATEGORY_OTHER ;
	if (false !== $m->addResourceInCategory($px_ar_id, $px_ar_category_id, $type)) {
		header('Location: articles.php?resource_id='.$px_ar_id);
		exit;
	}
}


if (!empty($_GET['delcat']) && !empty($px_ar_id) && $is_editable) {
	if (false !== $m->removeResourceFromCategory($px_ar_id, $px_ar_category_id)) {
		header('Location: articles.php?resource_id='.$px_ar_id);
		exit;
	}
}

if (!empty($_POST['delete']) && $is_editable) {
	if ($m->delArticle($px_ar_id) !== false) {
		$msg =  __('The article was successfully deleted.');
		header('Location: articles.php?op=list&msg='.urlencode($msg));
		exit;
	}
}

/*=================================================
 Get the categories for the article, array of status
 array for the dates
=================================================*/
if ($is_editable) {
	$arry_cat = $m->getArrayCategories();

	// Status
	$arry_status[ __('In edition')]	 = PX_RESOURCE_STATUS_INEDITION;
	if ($px_ar_pages->nbRow() >= 1) {
		$arry_status[ __('Waiting for validation')] = PX_RESOURCE_STATUS_TOBEVALIDATED;
		if (authAsLevel(PX_USER_LEVEL_ADVANCED, $_SESSION['website_id']))
			$arry_status[ __('On-line')]	= PX_RESOURCE_STATUS_VALIDE;
	}
	$arry_status[ __('Off-line')]	   = PX_RESOURCE_STATUS_OFFLINE;


	// Table of the months
	for ($i=1; $i<=12; $i++) {
		$month = sprintf('%02d', $i);
		$arry_dt_m[if_utf8(strftime('%B', strtotime('2000-'.$month.'-01')))] = $month;
	}

}
endif; // end of if (empty($_REQUEST['op']))



/*===============================================================
 Add/edit a page
===============================================================*/
/*=================================================
 Set values from submitted form case 'page'
=================================================*/
if (!empty($_REQUEST['op']) && ($_REQUEST['op'] == 'page')) {
	$px_ar_page_number         = '';
	$px_ar_page_id             = '';
	$px_ar_page_title          = '';
	$px_ar_page_content        = '';
	$px_ar_page_content_format = $m->user->getPref('content_format');
	$px_ar_page_creationdate   = '';
	$px_ar_page_modifdate      = '';
}
if (!empty($_REQUEST['a_page_id'])) {
	// page already exists
	$px_ar_pages->moveStart();
	$px_ar_page_id = $px_ar_pages->f('page_id');
	// get the requested page from the list of pages
	while ($_REQUEST['a_page_id'] != $px_ar_page_id) {
		if (false == $px_ar_pages->moveNext()) {
			$is_editable = false;
			$px_ar_page_id = '';
			$m->setError( __('Error: The requested page is not available.'), 400);
			break;
		} else {
			$px_ar_page_id = $px_ar_pages->f('page_id');
		}
	}
	if (!empty($px_ar_page_id)) {
		$px_ar_resource_id         = $px_ar_pages->f('resource_id');
		$px_ar_page_number         = $px_ar_pages->f('page_number');
		$px_ar_page_id             = $px_ar_pages->f('page_id');
		$px_ar_page_title          = $px_ar_pages->f('page_title');
		$px_ar_page_content        = textGetRawContent($px_ar_pages->f('page_content'));
		$px_ar_page_content_format = (($type = textGetType($px_ar_pages->f('page_content'))) !== false) ? $type : $m->user->getPref('content_format');
		$px_ar_page_creationdate   = $px_ar_pages->f('page_creationdate');
		$px_ar_page_modifdate      = $px_ar_pages->f('page_modifdate');
	}
}

if (   (!empty($_REQUEST['op']) && ($_REQUEST['op'] == 'page'))
	&& (!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform'])
	|| !empty($_POST['increase']) || !empty($_POST['increase_x']) || !empty($_POST['decrease']) || !empty($_POST['decrease_x']))
	&& $is_editable) {
	// case of a page, the page can be a new one (no id) or an existing one.
	$px_ar_page_number         = $_POST['a_page_number'];
	$px_ar_page_title          = $_POST['a_page_title'];
	$px_ar_page_content        = $_POST['a_page_content'];
	$px_ar_page_content_format = $_POST['a_page_content_format'];

	if (!empty($_POST['increase']) || !empty($_POST['increase_x'])) {
		$px_ar_page_textarea = $m->user->increase('article_textarea_page');
	}
	if (!empty($_POST['decrease']) || !empty($_POST['decrease_x'])) {
		$px_ar_page_textarea = $m->user->decrease('article_textarea_page');
	}

	if (!empty($_POST['transform'])) {
		$px_ar_page_content = textParseContent("=$px_ar_page_content_format\n".$px_ar_page_content);
		$px_ar_page_content_format = 'html';
	}
}

if (!empty($_REQUEST['op']) && ($_REQUEST['op'] == 'page')) {
	$px_ar_page_list = array();
	$np = $px_ar_pages->nbRow();
	if (empty($px_ar_page_id)) {
		$px_ar_page_list[ __('At the end')] = '';
	}
	for ($i = 1; $i<= $np; $i++) {
		$px_ar_page_list[(string) $i] = (string) $i;
	}
}

/*=================================================
 Add, edit a page - database operations
=================================================*/
if (!empty($_REQUEST['op']) && ($_REQUEST['op'] == 'page')):
if (!empty($_POST['publish']) && $is_editable) {
	if (!empty($px_ar_id) && !empty($px_ar_page_id)) {
		// edit
		$ar->setPage($px_ar_page_id, $px_ar_page_title, $px_ar_page_content, $px_ar_page_content_format, $px_ar_page_number);
		if (false !== ($id = $m->updArticlePage($ar))) {
			$msg =  __('The page was successfully saved.');
			header('Location: articles.php?op=page&resource_id='.$px_ar_id.'&a_page_id='.$id.'&msg='.urlencode($msg));
			exit;
		}
	} else {
		// new
		$m->user->savePref('content_format', $px_ar_page_content_format, $_SESSION['website_id']);
		$ar->setPage($px_ar_page_id, $px_ar_page_title, $px_ar_page_content, $px_ar_page_content_format, $px_ar_page_number);
		if (false !== ($id = $m->addArticlePage($ar))) {
			$msg =  __('The page was successfully added.');
			header('Location: articles.php?op=page&resource_id='.$px_ar_id.'&a_page_id='.$id.'&msg='.urlencode($msg));
			exit;
		}
	}
}

if (!empty($_POST['delete']) && !empty($px_ar_id) && !empty($px_ar_page_id) && $is_editable) {
	if (false !== $m->delArticlePage($px_ar_id, $px_ar_page_id)) {
		$msg =  __('The page was deleted.');
		header('Location: articles.php?resource_id='.$px_ar_id.'&msg='.urlencode($msg));
		exit;
	}
}


endif; // end of Add, edit a page - database operations

/*===============================================================
 List the articles
===============================================================*/
if (!empty($_REQUEST['op']) && 'list' == $_REQUEST['op']):

//Get the category id and save it
$cat_id = (!empty($_GET['cat_id'])) ? $_GET['cat_id'] : $m->user->getPref('list_articles_cat_id');
$m->user->savePref('list_articles_cat_id', $cat_id, $_SESSION['website_id'], true);
if ($cat_id == 'allcat') $cat_id = '';

//Get the search query
$px_q = (!empty($_GET['q'])) ? $_GET['q'] : '';

//Get available months and selected
list($first, $last, $arry_months) = $m->getArrayMonths('articles', $cat_id);
$px_m_s = $m->user->getPref('list_articles_month');
$px_m = (!empty($_GET['m'])) ? $_GET['m'] : ((!empty($px_m_s)) ? $px_m_s : $last);
$m->user->savePref('list_articles_month', $px_m, $_SESSION['website_id'], true);

if ($px_m == 'alldate') {
    $px_m = $first;
    $px_end   =  timestamp(0, 1 /*1 month after now*/, 0);
} else {
    $px_end   =  timestamp(0, 1 /*1 month after $px_m */, 0, makeTime($px_m));
}

if (empty($px_q)) {
	$res = $m->getResources(''/* All users */, '' /* All status */, $cat_id, 'articles', $px_m /*Date start */, $px_end /*Date end */);
	//get again as possibly modified because of the 'alldate' case
	$px_m = $m->user->getPref('list_articles_month');
} else {
	$res = $m->searchResources($px_q, false /*Not only the online resources */, 'articles', 'Article' /*Class used for the results */);
	//Search is made on all the date and all the categories
	$px_m = 'alldate';
	$cat_id = 'allcat';
}

// Categories
$arry_cat = $m->getArrayCategories(true);


endif;

/*==============================================================================
 Display block
==============================================================================*/

/*=================================================
 Set title of the page, and load common top page
=================================================*/
$px_title =  __('Articles');
include $_PX_config['manager_path'].'/mtemplates/_top.php';

echo '<h1>'. __('Articles')."</h1>\n\n";


/*===============================================================
 add/edit/view an article
===============================================================*/
if (empty($_REQUEST['op'])):

/*=================================================
 Preview of the content if some content is available
=================================================*/
if (strlen($px_ar_description)) {
	echo '<div class="preview">';

	if (!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform']))
		$px_ar_title_preview = textSecureString($px_ar_title);
	else $px_ar_title_preview = $px_ar_title;

	echo '<h3>'.$px_ar_title_preview.'</h3>';
	echo textParseContent("=$px_ar_description_format\n".$px_ar_description);
	echo "<hr class='invisible' id=\"zzz\"/></div>\n\n";

	if (!$is_editable) {
		while (!$px_ar_pages->EOF()) {

			echo '<div class="preview">';
			echo '<h3>'.$px_ar_pages->f('page_title').'</h3>';
			echo textParseContent($px_ar_pages->f('page_content'));
			echo "<hr class='invisible' id=\"zzz\"/></div>\n\n";


			$px_ar_pages->moveNext();
		}

	}
}
/*=================================================
 If is editable form to modify the content
=================================================*/
?>
<?php if ($is_editable) : ?>
  <form action="articles.php" method="post" id="formPost" onsubmit="return isReady('a_title','<?php echo __('You need to give a title.') ?>')">
  <?php
	if ($px_ar_categories->nbRow() >= 1) {

		//echo '<p><strong>'. __('Categories:').'</strong>'."</p>\n\n";
		echo '<fieldset><legend>'. __('Categories').'</legend>'."\n\n";
		echo "<ol>\n";
		while (!$px_ar_categories->EOF()) {
			echo '<li>'.$px_ar_categories->f('category_name');
			if ($px_ar_categories->f('categoryasso_type') != PX_RESOURCE_CATEGORY_MAIN) {
				echo ' - <a href=\'articles.php?delcat=1&amp;resource_id='.$px_ar_id.'&amp;a_category_id='.$px_ar_categories->f('category_id').'\' title=\''. __('Remove from this category').'\'>';
				echo '<img src="themes/'.$_px_theme.'/images/delete.png" alt="'. __('Remove from this category').'"></a> ';
				echo ' <a href=\'articles.php?addcategory=main&amp;resource_id='.$px_ar_id.'&amp;a_category_id='.$px_ar_categories->f('category_id').'\' title=\''. __('Set as main category').'\'>';
				echo '<img src="themes/'.$_px_theme.'/images/ico_set_as_home.png" alt="'. __('Remove from this category').'"></a> ';
			} else {
				echo ' - <img src="themes/'.$_px_theme.'/images/ico_home.png" alt="'. __('Main category').'"></a>';
			}
			echo "</li>\n";
			$px_ar_categories->moveNext();
		}
		echo "</ol>\n\n";
  ?>
  <p>
  <span class="nowrap"><label for="a_category_id"
  style="display:inline"><?php  echo __('Add in another category'); ?> <?php $m->HelpLink('article', 'h-category'); ?></label><br />
  <?php echo php_f_combobox('a_category_id',$arry_cat,'',1); ?>
  <input name="addcategory" type="submit" tabindex="2" class="submit" value="<?php  echo __('Add'); ?>" />
  </span></p></fieldset><p>
  <?php

	} else { // no category for the moment
  ?>
  <p>
  <span class="nowrap"><label for="a_category_id"
  style="display:inline"><?php  echo __('Category'); ?></label> <?php $m->HelpLink('article', 'h-category'); ?>
  <?php echo php_f_combobox('a_category_id', $arry_cat, $px_ar_category_id, 1); ?></span>
  <?php
	} // end off no category for the moment
   ?>
  <span class="nowrap"><label for="a_description_format"
  style="display:inline"><?php  echo __('Format'); ?></label> <?php $m->HelpLink('article', 'h-format'); ?>
  <?php
  echo php_f_combobox('a_description_format',array('HTML'=>'html','Wiki'=>'wiki'),$px_ar_description_format, 3);
  ?></span>

  <span class="nowrap"><label for="a_status"
  style="display:inline"><?php  echo __('Status'); ?></label> <?php $m->HelpLink('article', 'h-status'); ?>
  <?php
  echo php_f_combobox('a_status', $arry_status, $px_ar_status, 4);
  ?></span>

<?php if (count($arry_subtypes) > 1) { ?>
  <span class="nowrap"><label for="a_subtype"
  style="display:inline"><?php  echo __('Type'); ?></label>
  <?php  echo php_f_combobox('a_subtype', $arry_subtypes, $px_ar_subtype, 5);  ?>
  </span>
  </p>
<?php } else {
	echo php_f_hidden('a_subtype', array_shift($arry_subtypes));
} ?>

  <p><label for="a_title"><strong><?php  echo __('Title'); ?></strong> <?php $m->HelpLink('article', 'h-title'); ?></label>
  <?php echo php_f_textField('a_title', 30, 255, $px_ar_title, 6, 'style="width:100%" onkeyup="setUrl(\'a_title\', \'a_path\', \'\', '.strlen($px_ar_path).')"'); ?>
  </p>

  <p>
	<span class="bloc-droite"><img src="themes/<?php echo $_px_theme; ?>/images/ico_image.png" alt="" />
  <strong><a href="xmedia.php" accesskey="i"
  onclick="popup(this.href+'?mode=popup'); return false;"><?php  echo __('Insert an image or a file'); ?></a></strong></span>
  <label for="a_description"><strong><?php  echo __('Description'); ?></strong> <?php $m->HelpLink('article', 'h-description'); ?></label>
  <?php
  echo php_f_textArea('a_description',60,$px_ar_textarea,
  		htmlspecialchars($px_ar_description), 7,'style="width:100%"');
  ?>
   <span class="size-control">
   <input type="image" alt="<?php echo __('shrink textarea'); ?>" name="decrease" value="<?php  echo '-'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_shrink.png" accesskey="-" class="size-control" />
   <input type="image" alt="<?php echo __('grow textarea'); ?>" name="increase" value="<?php  echo '+'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_grow.png" accesskey="+" class="size-control" />
   </span>
  </p>

  <p><label for="a_subject"><?php  echo __('Keywords'); ?> <?php $m->HelpLink('article', 'h-keywords'); ?></label>
  <?php
  echo php_f_textArea('a_subject',60,4,
  		htmlspecialchars($px_ar_subject), 8,'style="width:100%"');
  ?>
  </p>
  <p><label for="a_path"><strong><?php  echo __('Path'); ?></strong> <?php $m->HelpLink('article', 'h-path'); ?></label>
  <?php echo php_f_textField('a_path', 30, 255, $px_ar_path, 9, 'style="width:100%"'); ?>
  </p>

  <?php
  if (!empty($px_ar_id))
  {
	echo '<p>'. __('Publication date').' ';
	$m->HelpLink('article', 'h-publication-date');
	echo ' '.php_f_textField('a_dt_d',2,2,$dt_d, 9).' '.
		php_f_combobox('a_dt_m',$arry_dt_m,$dt_m, 9).' '.
		php_f_textField('a_dt_y',4,4,$dt_y, 9).' '.
		 __('Time:').' '.
		php_f_textField('a_dt_h',2,2,$dt_h, 9).':'.
		php_f_textField('a_dt_i',2,2,$dt_i, 9).':'.
		php_f_textField('a_dt_s',2,2,$dt_s, 9).
		"<br />\n";
		$noenddate_style = ($px_ar_noenddate) ? 'style="display: none"' : '';

	echo '<span class="nowrap">'.php_f_checkbox('a_noenddate', 1, $px_ar_noenddate, 10, "onclick=\"openCloseSpan('noenddate',0)\"; return false;").' '.
		'<label for="a_noenddate" style="display:inline">'. __('Do not use an expiration date.').'</label></span>'.
		' <span class="nowrap" id="noenddate" '.$noenddate_style.'><br />'. __('Expiration date').' ';
	$m->HelpLink('article', 'h-expiration-date');
	echo ' '.php_f_textField('a_dt_e_d',2,2,$dt_e_d,11).' '.
		php_f_combobox('a_dt_e_m',$arry_dt_m,$dt_e_m,11).' '.
		php_f_textField('a_dt_e_y',4,4,$dt_e_y,11).' '.
		 __('Time:').' '.
		php_f_textField('a_dt_e_h',2,2,$dt_e_h,11).':'.
		php_f_textField('a_dt_e_i',2,2,$dt_e_i,11).':'.
		php_f_textField('a_dt_e_s',2,2,$dt_e_s,11).' '. "</span></p>\n\n";
  }

  if (!empty($px_ar_id)) {
  //  list the pages, link to add a new page
	echo '<fieldset><legend>'. __('Article pages').'</legend>'."\n\n";
	if ($px_ar_pages->nbRow() >= 1) {
		echo "<ol>\n";
		while (!$px_ar_pages->EOF()) {
			echo '<li><a tabindex="4'.$px_ar_pages->f('page_number').'" ';
			echo 'href=\'articles.php?op=page&amp;resource_id='.$px_ar_id.'&amp;a_page_id='.$px_ar_pages->f('page_id').'\' title=\''. __('Edit this page').'\'>'
				.$px_ar_pages->f('page_title').'</a> ';
			echo "</li>\n";
			$px_ar_pages->moveNext();
		}
		echo "</ol>\n\n";
	}
	echo '<p><a tabindex="900" href="articles.php?op=page&amp;resource_id='.$px_ar_id.'">'.__('Add a page to the article').'</a></p>';
	echo '</fieldset>'."\n";
  } else {
		echo '<p><strong>'. __('You need first to save the article, before adding a page to it.').'</strong></p>';
  }
  ?>

  <p><input name="preview" type="submit" class="submit" tabindex="912" value="<?php  echo __('Visualize [v]'); ?>"
  accesskey="v" />&nbsp;
  <input name="publish" type="submit" class="submit" tabindex="913" value="<?php  echo __('Save [s]'); ?>"
  accesskey="s" />
  <?php
  if (!empty($px_ar_id) && $px_ar_description_format == 'wiki') {
  	echo '&nbsp;<input tabindex="914" name="transform" type="submit" class="submit" '.
	'value="'. __('Transform in XHTML').'" />';
  }

  if (!empty($px_ar_id)) {
	echo '&nbsp;<input tabindex="915" name="delete" type="submit" class="submit" '.
	'value="'.  __('Delete').'" onclick="return '.
	'window.confirm(\''.addslashes( __('Are you sure you want to delete this article?')).'\')" />';
	echo php_f_hidden('resource_id',$px_ar_id);
  } ?>
  </p>
  </form>
	<h3><a onclick="openClose('wikihelp',0); return false" href="#"><img alt="<?php  echo __('show/hide'); ?>" id="img_wikihelp" src="themes/<?php echo $_px_theme; ?>/images/plus.png" /></a>
  <?php  echo __('Wiki syntax'); ?></h3>
  <div id="wikihelp" style="display: none;">
  <?php echo $m->getHelp('wiki-inline'); ?>
  </div>
  <script type="text/javascript"><!--
  openClose('wikihelp',-1);
  //--></script>
  <?php




	endif; // end of if ($is_editable)
endif; // end of add/edit/view a news

/*===============================================================
 Add/edit a page
===============================================================*/
if (!empty($_REQUEST['op']) && 'page' == $_REQUEST['op']):
/*=================================================
 Preview of the content if some content is available
=================================================*/
$link = '<a tabindex="1" href="articles.php?resource_id='.$ar->f('resource_id').'">'.$ar->f('title').'</a>';

if (strlen($px_ar_page_content)) {
	if ($is_editable) {
		echo '<p>'.sprintf(__('Your are editing page %s of the article: %s.'),
		'<strong>'.$px_ar_page_number.'</strong>', $link).'</p>';
	}
	echo '<div class="preview">';

	if (!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform']))
		$px_ar_page_title_preview = textSecureString($px_ar_page_title);
	else $px_ar_page_title_preview = $px_ar_page_title;

	echo '<h1 class="title">'.$px_ar_page_title_preview.'</h1>';
	echo textParseContent("=$px_ar_page_content_format\n".$px_ar_page_content);
	echo "<hr class='invisible' id=\"zoubida\"/></div>\n\n";
} else {
	echo '<p>'.sprintf(__('Your are adding a page to the article: %s.'), $link).'</p>';
}
/*=================================================
 If is editable form to modify the page content
=================================================*/
if ($is_editable) : ?>
  <form action="articles.php" method="post" id="formPost" onsubmit="return isReady('a_page_title','<?php echo __('The page must have a title.') ?>')">
  <p>
  <span class="nowrap"><label for="a_page_number"
  style="display:inline"><?php  echo __('Number of the page'); ?> <?php $m->HelpLink('article', 'h-page-number'); ?></label>
  <?php
  echo php_f_combobox('a_page_number',$px_ar_page_list,$px_ar_page_number,2);
  ?></span>

  <span class="nowrap"><label for="a_page_content_format"
  style="display:inline"><?php  echo __('Format'); ?> <?php $m->HelpLink('article', 'h-format'); ?></label>
  <?php
  echo php_f_combobox('a_page_content_format',array('HTML'=>'html','Wiki'=>'wiki'),$px_ar_page_content_format,3);
  ?></span>

  </p>

  <p><label for="a_page_title"><strong><?php  echo __('Page title'); ?></strong> <?php $m->HelpLink('article', 'h-page-title'); ?></label>
  <?php echo php_f_textField('a_page_title', 30, 255, $px_ar_page_title, 4, 'style="width:100%"'); ?>
  </p>

  <p>
	<span class="bloc-droite"><img src="themes/<?php echo $_px_theme; ?>/images/ico_image.png" alt="" />
  <strong><a href="xmedia.php" accesskey="i"
  onclick="popup(this.href+'?mode=popup'); return false;"><?php  echo __('Insert an image or a file'); ?></a></strong></span>
  <label for="a_page_content"><strong><?php  echo __('Page content'); ?></strong> <?php $m->HelpLink('article', 'h-page-content'); ?></label>
  <?php
  echo php_f_textArea('a_page_content',60,$px_ar_page_textarea,
  		htmlspecialchars($px_ar_page_content),5,'style="width:100%"');
  ?>
   <span class="size-control">
   <input type="image" alt="<?php echo __('shrink textarea'); ?>" name="decrease" value="<?php  echo '-'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_shrink.png" accesskey="-" class="size-control" />
   <input type="image" alt="<?php echo __('grow textarea'); ?>" name="increase" value="<?php  echo '+'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_grow.png" accesskey="+" class="size-control" />
   </span>
  </p>

  <p><a href="articles.php?resource_id=<?php echo $px_ar_id; ?>"><?php  echo __('Back to the article'); ?></a></p>

  <p><input name="preview" tabindex="6" type="submit" class="submit" value="<?php  echo __('Visualize [v]'); ?>"
  accesskey="v" />&nbsp;
  <input name="publish" tabindex="7" type="submit" class="submit" value="<?php  echo __('Save [s]'); ?>"
  accesskey="s" />
  <?php
  echo php_f_hidden('op','page');
  echo php_f_hidden('resource_id',$px_ar_id);
  if (!empty($px_ar_page_id) && $px_ar_description_format == 'wiki') {
  	echo '&nbsp;<input name="transform" tabindex="8" type="submit" class="submit" '.
	'value="'. __('Transform in XHTML').'" />';
  }

  if (!empty($px_ar_page_id)) {
	echo '&nbsp;<input name="delete" tabindex="9" type="submit" class="submit" '.
	'value="'.  __('Delete').'" onclick="return '.
	'window.confirm(\''.addslashes( __('Are you sure you want to delete this page?')).'\')" />';
	echo php_f_hidden('resource_id',$px_ar_id);

  }
  if (!empty($px_ar_page_id)) {
   echo php_f_hidden('a_page_id',$px_ar_page_id);
  }
  ?></p>
  </form>
	<h3><a onclick="openClose('wikihelp',0); return false" href="#"><img alt="<?php  echo __('show/hide'); ?>" id="img_wikihelp" src="themes/<?php echo $_px_theme; ?>/images/plus.png" /></a>
  <?php  echo __('Wiki syntax'); ?></h3>
  <div id="wikihelp" style="display: none;">
  <?php echo $m->getHelp('wiki-inline'); ?>
  </div>
  <script type="text/javascript"><!--
  openClose('wikihelp',-1);
  //--></script>
<?php




	endif; // end of is page editable
endif; // end of add/edit a page

/*===============================================================
 list articles
===============================================================*/
if (!empty($_REQUEST['op']) && 'list' == $_REQUEST['op']):

echo '<form action="articles.php" method="GET"><p>';
echo '<label for="m" style="display:inline;"><strong>'. __('Month:').' </strong></label>';
echo php_f_comboBox('m',$arry_months, $px_m);
echo ' <label for="cat_id" style="display:inline;"><strong>'. __('Category:').' </strong></label>';
echo php_f_comboBox('cat_id',$arry_cat,$cat_id);
echo ' <input type="hidden" name="op" id="op" value="list" /><input class="submit" type="submit" value="'. __('ok').'" />';
echo '</p></form>';

if ($res->isEmpty()) {
	echo '<p>'. __('No article').'</p>'."\n\n";
} else {
	echo '<script type="text/javascript">'."\n".
		"<!--\n".
		"var js_post_ids = new Array('".implode("','",$res->getIDs('content'))."');\n".
		"//-->\n".
		"</script>\n";

	echo '<p class="small"><a href="#" onclick="mOpenClose(js_post_ids,1); return false;">'. __('Show all').'</a>'.
	' - <a href="#" onclick="mOpenClose(js_post_ids,-1); return false;">'. __('Hide all').'</a></p>';


	while (!$res->EOF()) {
		// edition links - yes dotclear is a really good reference :o)
		if ($m->user->user['user_id'] == $res->f('user_id') || authAsLevel(PX_AUTH_ADMIN, $_SESSION['website_id'])) {
			$editlinks = '[<strong><a href="'.$res->f('type_id').'.php?resource_id='.$res->f('resource_id').'">'. __('edit').'</a></strong>]';
		} else {
			$editlinks = '[<strong><a href="'.$res->f('type_id').'.php?resource_id='.$res->f('resource_id').'">'. __('visualize').'</a></strong>]';
		}

		$res_class = '';
		$res_img = '';

		if ($res->f('status') == PX_RESOURCE_STATUS_OFFLINE) {
			$res_class = 'cancel';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_off.png" alt="'. __('Resource off-line').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_VALIDE) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_on.png" alt="'. __('Resource on-line').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_INEDITION) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_edit.png" alt="'. __('Resource in edition').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_TOBEVALIDATED) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_wait.png" alt="'. __('Resource waiting for validation').'" class="status" />';
		}

		echo '<div class="line '.$res_class.'" id="p'.$res->f('resource_id').'">'.
			'<p><a href="#" onclick="openClose(\'content'.$res->f('resource_id').'\',0); return false;">'.
			'<img src="themes/'.$_px_theme.'/images/plus.png" id="img_content'.$res->f('resource_id').'" '.
			'alt="'. __('show/hide').'" /></a> ';

		$authors = $res->getAuthors();
		echo $res->f('title').' - '. __('by');

		$temp = '';
		while (!$authors->EOF()) {
			$temp .= ' <strong>'.$authors->f('user_realname').'</strong>';
			$authors->moveNext();
		}
		echo $temp;
		echo ' - '. __('in');
		$cat = $res->getCategories();
		$temp = '';
		while (!$cat->EOF()) {
			$temp .= ' <em>'.$cat->f('category_name').'</em>,';
			$cat->moveNext();
		}
		$temp = substr($temp, 0, -1);
		echo $temp."<br />\n";
		echo $res_img.'<strong>'.date( __('Y/m/d \a\t H:i:s'),makeTime($res->f('modifdate'))).'</strong> '.$editlinks;

		echo "</p>\n\n";
		echo '<div id="content'.$res->f('resource_id').'" style="display:none;">';
		echo textParseContent($res->f('description'))."\n";
		echo "\n<p><span class='small'>". __('Id to make a link:').' '.$res->f('identifier')."</span></p>\n<hr class='invisible' /></div></div>\n\n";


		$res->moveNext();
	}
}

/*=================================================
 Form to search in the resources
=================================================*/
echo '<form action="articles.php" method="GET"><p>';
echo '<label for="q" style="display:inline;"><strong>'. __('Search:').' </strong></label>';
echo php_f_textField('q', 30, 255, $px_q);
echo ' <input class="submit" type="submit" value="'. __('ok').'" /><input type="hidden" name="op" value="list" />';
echo '</p></form>'."\n\n";

endif; // end of list articles

/*=================================================
 Load common bottom page
=================================================*/
include $_PX_config['manager_path'].'/mtemplates/_bottom.php';

?>
