<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_ADVANCED, (isset($_SESSION['website_id']))?$_SESSION['website_id']:'');

$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

$display_list_cat = false;
if (!empty($_REQUEST['category_id']) || !empty($_REQUEST['op'])) $display_list_cat = true;

$px_submenu->addItem( __('Categories'),  'categories.php',  'themes/'.$_px_theme.'/images/ico_cat.png', false, $display_list_cat);
$px_submenu->addItem( __('New category'), 'categories.php?op=add', 'themes/'.$_px_theme.'/images/ico_new.png', false);

/*===============================================================
 Process of the data
===============================================================*/
/*=================================================
 Set default values
=================================================*/
$is_editable = false;
if (!empty($_REQUEST['category_id']) || !empty($_REQUEST['op'])) {
	$px_cat_id                 = '';
	$px_cat_parentid           = '';
	$px_cat_name               = '';
	$px_cat_description        = '';
	$px_cat_description_format = $m->user->getPref('content_format');
	$px_cat_keywords           = '';
	$px_cat_path               = '';
	$px_cat_template           = '';
	$px_cat_cachetime          = '3600';
	$is_editable               = true;
	$px_cat_textarea           = $m->user->getPref('category_textarea');
}

/*=================================================
 Edition of a category
=================================================*/
if (!empty($_REQUEST['category_id'])):
if (false !== ($cat = $m->getCategory($_REQUEST['category_id']))) {
	if ($cat->nbRow() == 1) {
		$px_cat_id                 = $cat->f('category_id');
		$px_cat_parentid           = $cat->f('category_parentid');
		$px_cat_name               = $cat->f('category_name');
		$px_cat_description        = textGetRawContent($cat->f('category_description'));
		$px_cat_description_format = (($type = textGetType($cat->f('category_description'))) !== false) ? $type : $m->user->getPref('content_format');
		$px_cat_keywords           = $cat->f('category_keywords');
		$px_cat_path               = $cat->f('category_path');
		$px_cat_template           = $cat->f('category_template');
		$px_cat_cachetime          = $cat->f('category_cachetime');
	} else {
		$m->setError($m->get('categories_error_category_inexistant'));
		$is_editable = false;
	}
} else {
	$is_editable = false;
}
endif;

if ((!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform'])
     || !empty($_POST['increase']) || !empty($_POST['increase_x'])  || !empty($_POST['decrease']) || !empty($_POST['decrease_x']))
	&& $is_editable) {

	$px_cat_parentid           = ($px_cat_path == '/') ? $px_cat_parentid : $_POST['c_parentid'];
	$px_cat_name               = $_POST['c_name'];
	$px_cat_description        = $_POST['c_description'];
	$px_cat_description_format = $_POST['c_format'];
	$px_cat_keywords           = $_POST['c_keywords'];
	$px_cat_path               = ($px_cat_path == '/') ? $px_cat_path : $_POST['c_path'];
	$px_cat_template           = $_POST['c_template'];
	$px_cat_cachetime          = $_POST['c_cachetime'];

	if (!empty($_POST['transform'])) {
		$px_cat_description = textParseContent("=$px_cat_description_format\n".$px_cat_description);
		$px_cat_description_format = 'html';
	}

	if (!empty($_POST['increase']) || !empty($_POST['increase_x'])) {
		$px_cat_textarea = $m->user->increase('category_textarea');
	}
	if (!empty($_POST['decrease']) || !empty($_POST['decrease_x'])) {
		$px_cat_textarea = $m->user->decrease('category_textarea');
	}

	if (!empty($_POST['publish'])) {
		if (false !== $m->saveCategory($px_cat_id, $px_cat_parentid, $px_cat_name, $px_cat_description,
					$px_cat_description_format, $px_cat_keywords, $px_cat_path, $px_cat_template, $px_cat_cachetime)) {
			$msg =  __('Category successfully saved.');
			header('Location: categories.php?msg='.urlencode($msg));
			exit;
		}
	}
}

if (!empty($_POST['delete']) && $is_editable) {
	if ($m->delCategory($px_cat_id) !== false) {
		$msg =  __('The category was successfully deleted.');
		header('Location: categories.php?msg='.urlencode($msg));
		exit;
	}
}

if ($is_editable) {
	$cats = $m->getCategories();
	$arry_cat = array();
	$arry_cat_js = array();
	while (!$cats->EOF()) {
		$name =  $cats->f('category_name');
		$name .= ' ('.$cats->f('category_path').')';
		if (isGhostCat($cats->f('category_path'))) $name .= ' ['. __('Hidden category').']';
		$arry_cat[$name] = $cats->f('category_id');
		$cats->moveNext();
	}
	$arry_templates = $m->getTemplates('category');
}	

/*=================================================
 List the categories
=================================================*/
if (empty($_REQUEST['category_id']) && empty($_REQUEST['op'])):

$cats = $m->getCategories();

endif;


/*===============================================================
 Display of the data
===============================================================*/
/*=================================================
 title of the page
=================================================*/

$px_title =  __('Categories'); // used in _top.php
include $_PX_config['manager_path'].'/mtemplates/_top.php';

echo '<h1>'. __('Categories').'</h1>'."\n\n";

/*=================================================
 add/edit a category
=================================================*/
if ($is_editable):
/*=================================================
 Preview of the content if some content is available
=================================================*/
if (strlen($px_cat_description)) {
	echo '<div class="preview">';
	
	if (!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform']))
		$px_cat_name_preview = textSecureString($px_cat_name);
	else $px_cat_name_preview = $px_cat_name;
		
	echo '<h3>'.$px_cat_name_preview.'</h3>';
	echo textParseContent("=$px_cat_description_format\n".$px_cat_description);
	echo "<hr class='invisible' id=\"zoubida\"/></div>\n\n";
}

echo '<script type="text/javascript">'."\n".
"<!--\n".
"var js_pathlist = new Array();\n";
$cats->moveStart();
while (!$cats->EOF()) {	
	echo "js_pathlist[".$cats->f('category_id')."] = '".$cats->f('category_path')."';\n";
	$cats->moveNext();
}	
echo "//-->\n". "</script>\n";

?>
  <form action="categories.php" method="post" id="formPost" name="formPost">
  <p>
  <?php if (($px_cat_path != '/' && !empty($px_cat_id)) || empty($px_cat_id)) { ?>
  <span class="nowrap"><label for="c_parentid"
  style="display:inline"><?php  echo __('Parent category:'); ?></label>
  <?php echo php_f_combobox('c_parentid', $arry_cat, $px_cat_parentid, '', '','onChange="catChangePath(js_pathlist);"'); ?></span>
  <?php } ?>
  
  <span class="nowrap"><label for="c_format"
  style="display:inline"><?php  echo __('Format:'); ?></label>
  <?php
  echo php_f_combobox('c_format',array('HTML'=>'html','Wiki'=>'wiki'),$px_cat_description_format);
  ?></span>
  </p>

  <p><label for="c_name"><strong><?php  echo __('Title:'); ?></strong></label>
  <?php echo php_f_textField('c_name', 30, 255, $px_cat_name, '', 'style="width:100%"  onkeyup="setUrl(\'c_name\', \'c_path\', \'cat\', js_pathlist)"'); ?>
  </p>

  <p>
	<span class="bloc-droite"><img src="themes/<?php echo $_px_theme; ?>/images/ico_image.png" alt="" />
  <strong><a href="xmedia.php"
  onclick="popup(this.href+'?mode=popup'); return false;"><?php  echo __('Insert an image or a file'); ?></a></strong></span>
  <label for="c_description"><strong><?php  echo __('Description:'); ?></strong></label>
  <?php
  echo php_f_textArea('c_description',60,$px_cat_textarea,
  		htmlspecialchars($px_cat_description),'','style="width:100%"');
  ?>
   <span class="size-control">
   <input type="image" alt="<?php echo __('shrink textarea'); ?>" name="decrease" value="<?php  echo '-'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_shrink.png" accesskey="-" class="size-control" />
   <input type="image" alt="<?php echo __('grow textarea'); ?>" name="increase" value="<?php  echo '+'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_grow.png" accesskey="+" class="size-control" />
   </span>
  </p>
  <p><label for="c_keywords"><?php  echo __('Keywords:'); ?></label>
  <?php
  echo php_f_textArea('c_keywords',60,2,
  		htmlspecialchars($px_cat_keywords),'','style="width:100%"');
  ?>
  </p>
  <p><label for="c_path"><strong><?php  echo __('Path <span class="small">(/category/ or /cat/subcat/)</span>:'); ?></strong></label>
  <?php
	if ($px_cat_path == '/' && !empty($px_cat_id)) echo '<strong>/</strong>';
	else echo php_f_textField('c_path', 30, 255, $px_cat_path, '', 'style="width:100%"');
  ?>
  </p>
  <p>
  <span class="nowrap">
  <label for="c_template" style="display:inline"><strong><?php  echo __('Template:'); ?></strong></label>
  <?php echo php_f_combobox('c_template', $arry_templates, $px_cat_template); ?></span>

  <span class="nowrap"><label for="c_cachetime" style="display:inline"><strong><?php  echo __('Cache time in seconds:'); ?></strong></label>
  <?php echo php_f_textField('c_cachetime', 30, 255, $px_cat_cachetime, ''); ?></span>
  </p>
  
  <p><input name="preview" type="submit" class="submit" value="<?php  echo __('Visualize [v]'); ?>"
  accesskey="v" />&nbsp;
  <input name="publish" type="submit" class="submit" value="<?php  echo __('Save [s]'); ?>"
  accesskey="s" />

  <?php
  if (!empty($px_cat_id) && $px_cat_description_format == 'wiki')
  {
  	echo '&nbsp;<input name="transform" type="submit" class="submit" '.
	'value="'. __('Transform in XHTML').'" />';
  }

  if (!empty($px_cat_id) && $px_cat_path != '/')  {
	echo '&nbsp;<input name="delete" type="submit" class="submit" '.
	'value="'.  __('Delete').'" onclick="return '.
	'window.confirm(\''.addslashes( __('Are you sure you want to delete this category?')).'\')" />';
  }
  if (!empty($px_cat_id))  {
	echo php_f_hidden('category_id',$px_cat_id);
  } else {
	echo php_f_hidden('op','add');
  }
  echo php_f_hidden('quirk_category_path',strlen($px_cat_path));
  ?></p>
  </form>
	<h3><a onclick="openClose('wikihelp',0); return false" href="#"><img alt="<?php  echo __('show/hide'); ?>" id="img_wikihelp" src="themes/<?php echo $_px_theme; ?>/images/plus.png" ></a>
  <?php  echo __('Wiki syntax'); ?></h3>
  <div id="wikihelp" style="display: none;">
  <?php echo $m->getHelp('wiki-inline'); ?>
  </div>
  <script type="text/javascript"><!--
  openClose('wikihelp',-1);
  //--></script>
  <?php
endif; //end of $is_editable
/*=================================================
 list categories
=================================================*/
if (empty($_REQUEST['category_id']) && empty($_REQUEST['op'])):

if ($cats->isEmpty()) {
	echo '<p>'. __('No categories.').'</p>'."\n\n";
} else {
	echo '<script type="text/javascript">'."\n".
		"<!--\n".
		"var js_post_ids = new Array('".implode("','",$cats->getIDs('content','category_id'))."');\n".
		"//-->\n".
		"</script>\n";
	
	echo '<p class="small"><a href="#" onclick="mOpenClose(js_post_ids,1); return false;">'. __('Show all').'</a>'.
	' - <a href="#" onclick="mOpenClose(js_post_ids,-1); return false;">'. __('Hide all').'</a></p>';

   
	while (!$cats->EOF()) {

		echo '<div class="line" id="p'.$cats->f('category_id').'">'.
			'<p><a href="#" onclick="openClose(\'content'.$cats->f('category_id').'\',0); return false;">'.
			'<img src="themes/'.$_px_theme.'/images/plus.png" id="img_content'.$cats->f('category_id').'" '.
			'alt="'. __('show/hide').'" /></a> ';
   
		echo '<a href="index.php?cat_id='.$cats->f('category_id').'"><strong>'.$cats->f('category_name').'</strong></a> <span class="small">'.$cats->f('category_path').'</span> [<a href="categories.php?category_id='.$cats->f('category_id').'"><strong>'. __('edit').'</strong></a>]';
  
		echo "</p>\n\n";
		echo '<div id="content'.$cats->f('category_id').'" style="display:none;">';
		echo '<p>'.textParseContent($cats->f('category_description'))."</p>\n";
		echo "<p><span class='small'>". __('Id to use in the templates:').' '.$cats->f('category_id')."</span></p>";
		echo "\n<hr class='invisible' /></div></div>\n\n";	
		
		$cats->moveNext();
	}
}
endif;

include $_PX_config['manager_path'].'/mtemplates/_bottom.php';

?>
