<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

/** 
@class RenderManager loads the template and exposes the basic functions to get
categories, articles etc. in a page.

*/


include_once dirname(__FILE__).'/../inc/class.l10n.php';
include_once dirname(__FILE__).'/../inc/class.basicmanager.php';

class RenderManager extends BasicManager
{
	var $con       = null;
	var $art     = null;
	var $cat     = null;
	var $pcat    = null;
	var $subcat  = null;
	var $news    = null;
	var $site    = null;
	var $data    = array();
	var $res     = null; /**< Resources in the current category */
	var $lres    = null; /**< Last resources in the website */
	var $NbResPerPage = 10;


	function RenderManager()
	{
		global $_PX_website_config;
		$u = new RenderUser($_PX_website_config['website_id']);
		$this->setUser($u);
	}

	function getDB()
	{
		include_once dirname(__FILE__).'/../inc/lib.sqlutils.php';
		$this->con =& pxDBConnect();
	}
	
	function setParam($key, $value)
	{
		$GLOBALS['_PX_render']['params'][$key] = $value;
	}

	function getParam($key)
	{
		if (!empty($GLOBALS['_PX_render']['params'][$key])) {
			return $GLOBALS['_PX_render']['params'][$key];
		}
		return '';
	}

/*==============================================================================
 Start Functions to use in the templates
==============================================================================*/
	function getArticle($id, $page = 1)
	{
		include_once dirname(__FILE__).'/../inc/class.article.php';
		$this->getDB();
		if (false !== ($ar = $this->getResourceByIdentifier($id, 'Article'))) {
			$ar->getPages();
			if (false === $ar->pages->move($page - 1)) {
				$ar->currentpage = array_shift($ar->pages->getData());
			} else {
				$ar->currentpage = $ar->pages->arry_data[$page - 1];
			}
			return $ar;
		}
		return false;
	}

	function getNews($id)
	{
		include_once dirname(__FILE__).'/../inc/class.news.php';
		$this->getDB();
		if (false !== ($news = $this->getResourceByIdentifier($id, 'News'))) {
			$news->getDetails();
			return $news;
		}
		return false;
	}

	function getSite($id)
	{
		$this->getDB();
		return $this->getSites($id);
	}


	function getResources($category='', $limit = 10, $type = '',  $order = 'DESC')
	{
		include_once dirname(__FILE__).'/../inc/class.resource.php';
		$this->getDB();
		return parent::getResources('', PX_RESOURCE_STATUS_VALIDE, $category, $type, '', '', $limit, $order, true);
	}

	function getCategories($parentid = '', $order = 'ORDER BY category_path')
	{
		$this->getDB();
		$extra = 'category_path NOT LIKE \'%/\\_%\'';
		return parent::getCategories($parentid, $extra, $order);
	}

	function getCategory($id)
	{
		$this->getDB();
		return parent::getCategory($id);
	}
}


class RenderUser
{
	var $website = '';
	var $lang = '';

	function RenderUser($website)
	{
		$this->website = $website;
		$this->lang = '';
	}
}



?>
