<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_NORMAL, (isset($_SESSION['website_id']))?$_SESSION['website_id']:'');

$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

$mode = (!empty($_REQUEST['mode'])) ? $_REQUEST['mode'] : '';
$px_chapter = (!empty($_REQUEST['c'])) ? $_REQUEST['c'] : '';
$px_plugin = (!empty($_REQUEST['p'])) ? $_REQUEST['p'] : '';

/*=================================================
 title of the page
=================================================*/

$px_title =  __('Online help'); // used in _top.php

if ($mode == 'popup') {
	include dirname(__FILE__).'/mtemplates/_pop_top.php';
	echo '<p style="text-align: right;"><a href="#" onclick="window.close(); return false;">'.__('Close this window').'</a></p>';
} else {
	include dirname(__FILE__).'/mtemplates/_top.php';
	echo '<h1>'. __('Online help').'</h1>'."\n\n";
}
$help = '';
if ('' != $px_chapter) {
	$help = $m->getHelp($px_chapter, $px_plugin, true);
}
if ('' == $help) {
	$px_chapter = '';
}

if ('' != $px_chapter) {
	//display the requested help
	echo '<h1>'.$help[1].'</h1>'."\n\n";
	echo $help[2];
}

//display the list of help chapters
echo '<h1>'.__('Help topics').'</h1>';
$chapters = $m->getHelpChapters();
echo '<ul>'."\n";
foreach ($chapters as $c) {
	echo '<li><a href="help.php?c='.$c[0].'&amp;mode='.$mode.'">'.$c[1].'</a></li>'."\n";
}
echo '</ul>'."\n";

echo '<h2>'. __('More help').'</h2>'."\n\n";
echo '<p>'. __('You can read the <a href="http://plume-cms.net/doc/">complete online documentation</a>.').'</p>'."\n\n";
echo '<p>'. __('You can also ask your questions to the community on the <a href="http://plume-cms.net/forum/">forum</a>.').'</p>'."\n\n";



if ($mode == 'popup') {
	echo '<p style="text-align: right;"><a href="#" onclick="window.close(); return false;">'.__('Close this window').'</a></p>';
	include dirname(__FILE__).'/mtemplates/_pop_bottom.php';
} else {
	include dirname(__FILE__).'/mtemplates/_bottom.php';
}
?>
