<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

define('PX_RESOURCE_CATEGORY_MAIN',  1);
define('PX_RESOURCE_CATEGORY_OTHER', 2);

define('PX_RESOURCE_CREATOR',       1);
define('PX_RESOURCE_CONTRIBUTOR',   2);
define('PX_RESOURCE_TRANSLATOR',    3);

define('PX_RESOURCE_STATUS_VALIDE',         1);
define('PX_RESOURCE_STATUS_OFFLINE',        2);
define('PX_RESOURCE_STATUS_DEPRECATED',     3);
define('PX_RESOURCE_STATUS_INEDITION',      4);
define('PX_RESOURCE_STATUS_TOBEVALIDATED',  5);


require_once dirname(__FILE__).'/../extinc/class.recordset.php';

class Resource extends recordset 
{
	var $con        = null;
	var $categories = null;
	var $authors    = null;
	var $prefs      = array();
	var $website    = '';

	/** set the preferences from the user information.
	The preferences can include the default license for the
	content, the publisher, etc.
	*/
	function setPrefs($user)
	{
		$this->prefs = $user->prefs;
		return true;
	}

	function getPref($key, $websiteid = '')
	{
		global $_PX_config;
		if (strlen($key) == 0)
			return '';
		if (strlen($websiteid) == 0)
			$websiteid = $this->website;
		if (isset($this->prefs[$key][$websiteid]))
			return $this->prefs[$key][$websiteid];
		if (isset($this->prefs[$key]['#all#']))
			return $this->prefs[$key]['#all#'];
		if (isset($_PX_config[$key])) return $_PX_config[$key];
		return '';
	}

	function getCategories()
	{
		$this->getConnection();
		$r = 'SELECT * FROM '.$this->con->pfx.'categoryasso
		    LEFT JOIN '.$this->con->pfx.'categories ON
		    '.$this->con->pfx.'categoryasso.category_id='.$this->con->pfx.'categories.category_id
		    WHERE identifier=\''.$this->f('identifier').'\' ORDER BY categoryasso_type ASC';
		if (($rs = $this->con->select($r)) !== false) {
			$this->categories = $rs;
			return $rs;
		} else {
			$this->con->setError();
			return false;
		}
	}

	function getPath()
	{
		include_once dirname(__FILE__).'/lib.text.php';

		if ($this->f('type_id') == 'news') {
			return $this->f('category_path').$this->f('resource_id').'-'.textStr2url($this->f('title'));
		} else {
			return $this->f('category_path').$this->f('path');
		}

	}

	function getAuthors()
	{
		$this->getConnection();
		$r = 'SELECT * FROM '.$this->con->pfx.'users LEFT JOIN
		      '.$this->con->pfx.'authorasso USING (user_id)
		      WHERE resource_id=\''.$this->f('resource_id').'\' ORDER BY authorasso_type';
		if (($rs = $this->con->select($r)) !== false) {
			$type[PX_RESOURCE_CREATOR]     = 'creator';
			$type[PX_RESOURCE_CONTRIBUTOR] = 'contributor';
			$type[PX_RESOURCE_TRANSLATOR]  = 'translator';
			while (!$rs->EOF()) {
				$rs->setField('authorasso',$type[$rs->f('authorasso_type')]);
				$rs->moveNext();
			}
			$rs->moveStart();
			$this->authors = $rs;
			return $rs;
		} else {
			$this->con->setError();
			return false;
		}
	}

	/**
	Return the content of the news as a string ready for indexation.
	Must be overwritten for each type of resource.
	
	@param string Format of the string (html, wiki, text)
	@return string The content of the news as a string
	*/
	function getAsString($format = 'html')
	{
		return '';
	}

	function getConnection()
	{
		if ($this->con === null) $this->con =& pxDBConnect();
	}


	/** Get ids of resources with a prefix or not

	@note Available under MPL 1.1/GPL 2.0/LGPL 2.1 with DotClear Weblog
	More details: http://www.dotclear.net/
	@author Olivier Meunier
	@return array ids
	@param  string prefix for ids
	*/
	function getIDs($str='')
	{
		$res = array();

		$index = $this->int_index;
		$this->moveStart();

		while (!$this->EOF())
		{
			$res[] = $str.$this->f('resource_id');
			$this->moveNext();
		}
		$this->move($index);
		return $res;
	}


}

?>
