<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

/**
 * Create the path to a resource from a resource object
 *
 * @param  object resource
 * @return string path to the resource
 */
function pathToResource($res)
{
    global $_PX_context, $_PX_config;
    // Absolute path to resource, print it like that.
    if (ereg(':',$res->f('path')))
        return $res->f('path');

    if (isset($_PX_context['out'])) $base = $res->f('website_url');
    else $base = $res->f('website_reurl');
    if ($_PX_config['url_format'] == 'simple') $base .= '/?';
                
    // if type is xmedia the link is special
    if ('xmedia' == $res->f('type_id'))
        return  $base.$res->f('website_xmedia_reurl').$res->f('path');
    if ('news' == $res->f('type_id'))
        return $base.$res->f('category_path').$res->f('resource_id').'-'.textStr2url($res->f('title'));
    // else standard link
    return $base.$res->f('category_path').$res->f('path');
}


/**
 * Create the path to a category from the category object.
 *
 * @param  object category
 * @return string path to the category
 */
function pathToCategory($cat)
{
    global $_PX_context, $_PX_config;
    if (isset($_PX_context['out'])) $base = $res->f('website_url');
    else $base = $res->f('website_reurl');
    if ($_PX_config['url_format'] == 'simple') $base .= '/?';
    return $base.$cat->f('category_path');
}

/**
 * For the article it is possible to have multiple pages
 *
 * @param object resource
 * @param int number of the page
 * @return string path to the article page
 */
function pathToArticlePage($res, $page = 1)
{
    global $_PX_context, $_PX_config;
    if (isset($_PX_context['out'])) $base = $res->f('website_url');
    else $base = $res->f('website_reurl');
    if ($_PX_config['url_format'] == 'simple') $base .= '/?';
    if ($page == 1) $page = '';
    return $base.$res->f('category_path').$res->f('path').$page;
}

?>