<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_NORMAL, (isset($_SESSION['website_id']))?$_SESSION['website_id']:'');

$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

if (!empty($_REQUEST['goto'])) {
    $site = $_REQUEST['switchid'];
    if (isset($m->user->wdata[$site]['website_url'])) {
        $location = $m->user->wdata[$site]['website_url'] .'/';     
        header('Location: '.$location);
        exit;
    }        
}


if (!empty($_REQUEST['switchid'])) {
    $_SESSION['website_id'] = $_REQUEST['switchid'];
    $location = (!empty($_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : 'index.php';
    if (false !== ($pos = strpos($location, '?'))) {
        $location = substr($location, 0, $pos);
    }
    header('Location: '.$location);
    exit;
}


$px_submenu->addItem( __('News'), 'news.php', 'themes/'.$_px_theme.'/images/ico_news.png', false);
$px_submenu->addItem( __('Articles'), 'articles.php', 'themes/'.$_px_theme.'/images/ico_article.png', false);
$px_submenu->addItem( __('Files or images'), 'xmedia.php', 'themes/'.$_px_theme.'/images/ico_image.png', false);


/*=================================================
 list resources retrieval
=================================================*/
//Get the category id and save it
$cat_id = (!empty($_GET['cat_id'])) ? $_GET['cat_id'] : $m->user->getPref('list_index_cat_id');
$m->user->savePref('list_index_cat_id', $cat_id, $_SESSION['website_id'], true);
if ($cat_id == 'allcat') $cat_id = '';

//Get the search query
$px_q = (!empty($_GET['q'])) ? $_GET['q'] : '';

//Get available months and selected
list($first, $last, $arry_months) = $m->getArrayMonths(''/* All the types */, $cat_id);
$px_m_s = $m->user->getPref('list_index_month');
$px_m = (!empty($_GET['m'])) ? $_GET['m'] : ((!empty($px_m_s)) ? $px_m_s : $last);
$m->user->savePref('list_index_month', $px_m, $_SESSION['website_id'], true);

if ($px_m == 'alldate') {
    $px_m = $first;
    $px_end   =  timestamp(0, 1 /*1 month after now*/, 0);
} else {
    $px_end   =  timestamp(0, 1 /*1 month after $px_m */, 0, makeTime($px_m));
}

if (empty($px_q)) {
	$res = $m->getResources(''/* All users */, '' /* All status */, $cat_id, ''/*All types*/, $px_m /*Date start */, $px_end /*Date end */);
	//get again as possibly modified because of the 'alldate' case
	$px_m = $m->user->getPref('list_index_month');
} else {
	$res = $m->searchResources($px_q, false /*Not only the online resources */, '' /*All the types */);
	//Search is made on all the date and all the categories
	$px_m = 'alldate';
	$cat_id = 'allcat';
}

// Categories
$arry_cat = $m->getArrayCategories(true);




/*=================================================
 title of the page
=================================================*/

$px_title =  __('Home'); // used in _top.php
include $_PX_config['manager_path'].'/mtemplates/_top.php';

echo '<h1>'. __('Resource list').'</h1>'."\n\n";

/*=================================================
 Form to select the resources
=================================================*/
echo '<form action="index.php" method="GET"><p>';
echo '<label for="m" style="display:inline;"><strong>'. __('Month:').' </strong></label>';
echo php_f_comboBox('m',$arry_months, $px_m);
echo ' <label for="cat_id" style="display:inline;"><strong>'. __('Category:').' </strong></label>';
echo php_f_comboBox('cat_id',$arry_cat,$cat_id);
echo ' <input type="hidden" name="op" id="op" value="list" /><input class="submit" type="submit" value="'. __('ok').'" />';
echo '</p></form>';


/*=================================================
 list resources
=================================================*/
if ($res->isEmpty()) {
    echo '<p>'. __('No resource.').'</p>'."\n\n";
} else {
	echo '<script type="text/javascript">'."\n".
		"<!--\n".
		"var js_post_ids = new Array('".implode("','",$res->getIDs('content'))."');\n".
		"//-->\n".
		"</script>\n";
	
	echo '<p class="small"><a href="#" onclick="mOpenClose(js_post_ids,1); return false;">'. __('Show all').'</a>'.
	' - <a href="#" onclick="mOpenClose(js_post_ids,-1); return false;">'. __('Hide all').'</a></p>';

   
    while (!$res->EOF()) {
        // edition links - yes dotclear is a really good reference :o)
        if ($m->user->user['user_id'] == $res->f('user_id') || authAsLevel(PX_AUTH_ADMIN, $_SESSION['website_id'])) {
            $editlinks = '[<strong><a href="'.$res->f('type_id').'.php?resource_id='.$res->f('resource_id').'">'. __('edit').'</a></strong>]'; // - '. __('change the status').']';
        } else {
            $editlinks = '[<strong><a href="'.$res->f('type_id').'.php?resource_id='.$res->f('resource_id').'">'. __('visualize').'</a></strong>]';        
        }
        $res_class = '';
        $res_img = '';
        
		if ($res->f('status') == PX_RESOURCE_STATUS_OFFLINE) {
			$res_class = 'cancel';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_off.png" alt="'. __('Resource off-line').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_VALIDE) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_on.png" alt="'. __('Resource on-line').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_INEDITION) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_edit.png" alt="'. __('Resource in edition').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_TOBEVALIDATED) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_wait.png" alt="'. __('Resource waiting for validation').'" class="status" />';
		}     
                
        echo '<div class="line '.$res_class.'" id="p'.$res->f('resource_id').'">'.
			'<p><a href="#" onclick="openClose(\'content'.$res->f('resource_id').'\',0); return false;">'.
			'<img src="themes/'.$_px_theme.'/images/plus.png" id="img_content'.$res->f('resource_id').'" '.
			'alt="'. __('show/hide').'" /></a> ';
  
        $authors = $res->getAuthors();    
        echo $res->f('title').' - '. __('by');
  
        $temp = '';
        while (!$authors->EOF()) {
            $temp .= ' <strong>'.$authors->f('user_realname').'</strong>';
            $authors->moveNext();
        }
        echo $temp;
        echo ' - '. __('in');
        $cat = $res->getCategories();
        $temp = '';
        while (!$cat->EOF()) {
            $temp .= ' <em>'.$cat->f('category_name').'</em>,';
            $cat->moveNext();
        }
        $temp = substr($temp, 0, -1); 
        echo $temp."<br />\n";
        echo $res_img.'<strong> '.date( __('Y/m/d \a\t H:i:s'),makeTime($res->f('modifdate'))).'</strong> '.$editlinks;
        
        echo "</p>\n\n";
        echo '<div id="content'.$res->f('resource_id').'" style="display:none;">';
        echo textParseContent($res->f('description'))."\n";
        echo "\n<p><span class='small'>". __('Id to make a link:').' '.$res->f('identifier')."</span></p>\n<hr class='invisible' /></div></div>\n\n";
        
        $res->moveNext();
    }
}

/*=================================================
 Form to search in the resources
=================================================*/
echo '<form action="index.php" method="GET"><p>';
echo '<label for="q" style="display:inline;"><strong>'. __('Search:').' </strong></label>';
echo php_f_textField('q', 30, 255, $px_q); 
echo ' <input class="submit" type="submit" value="'. __('ok').'" />';
echo '</p></form>'."\n\n";

include $_PX_config['manager_path'].'/mtemplates/_bottom.php';

?>
