<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
require_once dirname(__FILE__).'/prepend.php';

$_px_p = 10; //percentage of wizard done.



if (empty($_SESSION['step1'])) {
	header('Location: index.php');
	exit;
}

//load the language file
$_PX_config['encoding'] = $_SESSION['encoding'];
$l = new l10n($_SESSION['lang'], 'install');

/* Check of the php installation */

//Check the php version
$checklist = new checklist('php', version_compare(phpversion(),'4.1','>='),
	sprintf(__('The installed PHP version is: %s.'), phpversion()),
	sprintf(__('The installed PHP version is: %s. PHP 4.1 or higher is required.'), phpversion()));
//Check the support of MySQL
$checklist->addTest('mysql', function_exists('mysql_connect'),
	__('The MySQL module is available.'),
	__('The MySQL module is not available.'));
//Check the support of the output buffer functions
$checklist->addTest('ob', function_exists('ob_start'),
	__('The output buffering functions are available.'),
	__('The output buffering functions are not available.'));
//Check the support of gd for thumbnails
//Note: the library version is not tested as the output buffering functions are needed.
//I may get the results of the test 'ob' and then if ok, check the version.
$checklist->addTest('gd', (function_exists('imagecreatefromjpeg')) ? 1 : 2,
	__('The GD library is available.'),
	'', /* no error in test only warning */
	__('The GD library is not available. Thumbnails will not be created automatically.'));
//Need the XML module for the SQL xml class
$checklist->addTest('xmlparser', function_exists('xml_parser_create'),
	__('The XML module is available.'),
	__('The XML module is not available.'));


/* Check of the read/write of the files */
// Files/folders to check:
// xmedia and xmedia/thumb
// conf folder and files in
// cache folder
// templates
// tools (warning only for the update manager)
$rp = $_PX_config['manager_path'];
//Configuration folder
$checklist->addTest('conf-folder', is_writable($rp.'/conf/'),
	sprintf(__('The system can write in the configuration folder: %s'), files::real_path($rp.'/conf/')),
	sprintf(__('The system cannot write in the configuration folder: %s. Check the permissions.'), files::real_path($rp.'/conf/')));
//Cache folder
$checklist->addTest('cache-folder', is_writable($rp.'/cache/'),
	sprintf(__('The system can write in the cache folder: %s'), files::real_path($rp.'/cache/')),
	sprintf(__('The system cannot write in the cache folder: %s. Check the permissions.'), files::real_path($rp.'/cache/')));
//Template folder
$checklist->addTest('templates-folder', is_writable($rp.'/templates/'),
	sprintf(__('The system can write in the template folder: %s'), files::real_path($rp.'/templates/')),
	sprintf(__('The system cannot write in the template folder: %s. Check the permissions.'), files::real_path($rp.'/templates/')));
//xmedia path and thumbnail path
$checklist->addTest('xmedia-folder', is_writable($rp.'/../xmedia/'),
	sprintf(__('The system can write in the document folder: %s'), files::real_path($rp.'/../xmedia/')),
	sprintf(__('The system cannot write in the document folder: %s. Check the permissions.'), files::real_path($rp.'/../xmedia/')));
$checklist->addTest('theme-folder', is_writable($rp.'/../xmedia/theme/'),
	sprintf(__('The system can write in the theme folder: %s'), files::real_path($rp.'/../xmedia/theme/')),
	sprintf(__('The system cannot write in the theme folder: %s. Check the permissions.'), files::real_path($rp.'/../xmedia/theme/')));
$checklist->addTest('thumb-folder', (is_writable($rp.'/../xmedia/thumb/')) ? 1 : 2,
	sprintf(__('The system can write in the thumbnail folder: %s'), files::real_path($rp.'/../xmedia/thumb/')),
	'', /*no error but warning */
	sprintf(__('The system cannot write in the thumbnail folder: %s. Check the permissions or you will not be able to have automatic creation of the thumbnails.'), files::real_path($rp.'/../xmedia/thumb/')));

$check = $checklist->checkAll();
if ($check) {
	$_SESSION['step2'] = true;
}
include dirname(__FILE__).'/_top.php';

echo '<h2>'.__('Check of the PLUME CMS support by the system').'</h2>'."\n\n";

echo $checklist->getHtml('../themes/default/images');

if ($check) {
	echo '<p>'.__('Congratulations, your system supports PLUME CMS. Warnings will not prevent your use of PLUME CMS.').'</p>'."\n";
	echo '<p>'.__('No irreversible action is taken during the installation process. You can revert your choices from the manager at a later time.').'</p>'."\n";


	echo '<p>'.sprintf(__('<a href="%s">Continue with the choice of languages</a>.'), 'encoding.php').'</p>'."\n";

} else {
    echo '<p>'.__('Some errors prevent the installation of PLUME CMS on your system. You can fix them and restart the wizard afterwards.').'</p>'."\n\n";
}
include dirname(__FILE__).'/_bottom.php';

?>
