<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
require_once dirname(__FILE__).'/prepend.php';

$_px_p = 100; //percentage of wizard done.

if (empty($_SESSION['step7'])) {
	header('Location: firstwebsite.php');
	exit;
}

//load the language file
$_PX_config['encoding'] = $_SESSION['manager_encoding'];
$l = new l10n($_SESSION['manager_lang'], 'install');
$l->loadDomain($_SESSION['manager_lang']); //load the general lang file

$_PX_config['db']['db_login']     = $_SESSION['dblogin'];
$_PX_config['db']['db_password']  = $_SESSION['dbpass'];
$_PX_config['db']['db_server']    = $_SESSION['dbserver'];
$_PX_config['db']['db_database']  = $_SESSION['dbname'];
$_PX_config['db']['table_prefix'] = $_SESSION['dbprefix'];
$_PX_config['debug'] = true;

$u = new User(1); //user with "root" id
$m = new Manager();
$m->setUser($u);
$error = false;
$error_mess = '';

$source_file      = dirname(__FILE__).'/../conf/config.php-dist';
$destination_file = dirname(__FILE__).'/../conf/config.php';
@copy($source_file, $destination_file);
@chmod($destination_file, 0666);

$cfg = new configfile($destination_file);
$cfg->prefix = "_PX_config['db']";
$cfg->editVar('db_login',     (string) $_PX_config['db']['db_login']);
$cfg->editVar('db_password',  (string) $_PX_config['db']['db_password']);
$cfg->editVar('db_server',    (string) $_PX_config['db']['db_server']);
$cfg->editVar('db_database',  (string) $_PX_config['db']['db_database']);
$cfg->editVar('table_prefix', (string) $_PX_config['db']['table_prefix']);

$cfg->prefix = '_PX_config';
$cfg->editVar('lang', (string) $_SESSION['manager_lang']);
$cfg->editVar('encoding', (string) $_SESSION['manager_encoding']);
$cfg->editVar('debug', false);

if (!$cfg->saveFile()) {
	$error_mess = __('Error: Impossible to create the configuration file.');
	$error = true;
}

include dirname(__FILE__).'/_top.php';

echo '<h2>'.__('End of the installation').'</h2>'."\n\n";

if($error === true) {
	echo '<p class="important">'.__('Errors during the creation of the configuration file. Check the online documentation to get the solution!').'</p>'."\n\n";
    echo "\n\n" . $error_mess . "\n\n";
} else {
	echo '<h3>'.__('Congratulations, PLUME CMS has been installed!').'</h3>'."\n\n";
}

echo '<p>'.__('The very last step is your work. You just have to create a new article or news into you website.').'</p>'."\n";
echo '<p>'.sprintf(__('You can now access the manager with the login and password you provided before. <a href="%s">Access the manager</a>.'), '../login.php?logout=1').'</p>'."\n";

include dirname(__FILE__).'/_bottom.php';
?>
