<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
require_once dirname(__FILE__).'/prepend.php';

$_px_p = 30; //percentage of wizard done.

//Get the info for the database.
/*
$_PX_config['db']['db_server']    = 'localhost'; // Server
$_PX_config['db']['db_database']  = 'plume'; // Name of the database
$_PX_config['db']['db_login']     = 'root'; // User/login to the database
$_PX_config['db']['db_password']  = ''; // Password
$_PX_config['db']['db_type']      = 'mysql'; // Type of database engine
$_PX_config['db']['table_prefix'] = 'plume_'; // Prefix on the tables to access them
*/

if (empty($_SESSION['step3'])) {
	header('Location: encoding.php');
	exit;
}

//load the language file
$_PX_config['encoding'] = $_SESSION['manager_encoding'];
$l = new l10n($_SESSION['lang'], 'install');

$px_dbserver = 'localhost';
$px_dbname = 'plume';
$px_dblogin = 'root';
$px_dbpass = '';
$px_dbprefix = 'plume_';
$px_dberror = false;


if (!empty($_POST['dbserver'])) {
	$px_dbserver = (!empty($_POST['dbserver'])) ? $_POST['dbserver'] : '';
	$px_dbname = (!empty($_POST['dbname'])) ? $_POST['dbname'] : '';
	$px_dblogin = (!empty($_POST['dblogin'])) ? $_POST['dblogin'] : '';
	$px_dbpass = (!empty($_POST['dbpass'])) ? $_POST['dbpass'] : '';
	$px_dbprefix = (!empty($_POST['dbprefix'])) ? $_POST['dbprefix'] : '';

	//try a connection and check the results
	$db = new Connection($px_dblogin, $px_dbpass, $px_dbserver, $px_dbname, $px_dbprefix, true);
	if ($db->error()) {
		$px_dberror = true;
		$px_mess = $db->error();
	} else {
		$_SESSION['dbserver'] = $px_dbserver;
		$_SESSION['dbname'] = $px_dbname;
		$_SESSION['dblogin'] = $px_dblogin;
		$_SESSION['dbpass'] = $px_dbpass;
		$_SESSION['dbprefix'] = $px_dbprefix;
		$_SESSION['step4'] = true;
		header('Location: dbinstall.php');
		exit;
	}

}



include dirname(__FILE__).'/_top.php';

if ($px_dberror) {
	echo '<p class="important">'.__('The system was enable to connect to the database, please check the error message and the information you provided to fix the problem.').'</p>'."\n\n";
	echo '<p>'.sprintf(__('Error message: %s'), $px_mess).'</p>'."\n\n";
}
echo '<h2>'.__('Database information').'</h2>'."\n\n";

echo '<p>'.__('The content of the website is saved into a MySQL database. Please provide the necessary data so to connect to the database.').'</p>'."\n\n";

?>
<form action="dbinfo.php" method="post" id="formPost">

<p class="field"><label for="dbserver"><strong><?php  echo __('Database server:'); ?></strong></label>
<?php echo php_f_textField('dbserver', 30, 255, $px_dbserver); ?>
</p>

<p class="field"><label for="dbname"><strong><?php  echo __('Database name:'); ?></strong></label>
<?php echo php_f_textField('dbname', 30, 255, $px_dbname); ?>
</p>

<p class="field"><label for="dblogin"><strong><?php  echo __('Login to access the database:'); ?></strong></label>
<?php echo php_f_textField('dblogin', 30, 255, $px_dblogin); ?>
</p>

<p class="field"><label for="dbpass"><strong><?php  echo __('Password to access the database:'); ?></strong></label>
<?php echo php_f_textField('dbpass', 30, 255, $px_dbpass); ?>
</p>

<p class="field"><label for="dbprefix"><strong><?php  echo __('Prefix for the tables in the database:'); ?></strong></label>
<?php echo php_f_textField('dbprefix', 30, 255, $px_dbprefix); ?><br />
<span class="small"><?php echo __('Change it only if you have several installations of PLUME CMS with the same database.'); ?></small>
</p>
<p><?php echo __('In the next step the database will be initialized with the necessary tables for PLUME CMS.'); ?></p>
<p>
<input name="next" type="submit" class="submit" value="<?php  echo __('Next'); ?>"  accesskey="n" />
</p>
</form>
<?php

include dirname(__FILE__).'/_bottom.php';

?>
