<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
require_once dirname(__FILE__).'/prepend.php';
$_px_p = 40; //percentage of wizard done.

if (empty($_SESSION['step4'])) {
	header('Location: dbinfo.php');
	exit;
}

//load the language file
$_PX_config['encoding'] = $_SESSION['manager_encoding'];
$l = new l10n($_SESSION['lang'], 'install');


$_PX_config['db']['db_login']     = $_SESSION['dblogin'];
$_PX_config['db']['db_password']  = $_SESSION['dbpass'];
$_PX_config['db']['db_server']    = $_SESSION['dbserver'];
$_PX_config['db']['db_database']  = $_SESSION['dbname'];
$_PX_config['db']['table_prefix'] = $_SESSION['dbprefix'];
$_PX_config['debug'] = true;

$con =& pxDBConnect();

$extra = '';
$rsV = $con->select('SELECT VERSION() AS version');
$mysql_version = preg_replace('/-log$/','',$rsV->f(0));
if (version_compare($mysql_version, '3.23', '>=')) {
    $extra = ' TYPE=MyISAM';
}

$checklist = new checklist();
$xml = implode("\n", file('./db-create.xml'));
$sql = new xmlsql($con, $xml);

$sql->replace('{{TYPE}}', $extra);
$sql->replace('{{PREFIX}}',$_PX_config['db']['table_prefix']);
$sql->execute($checklist);

$check = $checklist->checkAll();

if($check) {
	$_SESSION['step5'] = true;
}

include dirname(__FILE__).'/_top.php';

echo '<h2>'.__('Database installation').'</h2>'."\n\n";

if(!$check) {
	echo '<p class="important">'.__('Errors during database initialization procedure.').'</p>'."\n\n";
}

echo $checklist->getHtml('../themes/default/images');


if($check) {
	echo '<p>'.sprintf(__('In the next step the first user will be registered to use the system. <a href="%s">Next</a>.'), 'firstuser.php').'</p>'."\n\n";
}
include dirname(__FILE__).'/_bottom.php';
?>
