<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
require_once dirname(__FILE__).'/prepend.php';
$_px_p = 20; //percentage of wizard done.

//if current encoding is utf-8 we keep it and propose only possible languages
//for the manager interface.
//if encoding is iso-8859-1 we propose the list of supported languages by iso and
//give the choice to say "I need to write in more languages than the listed"
//if the user select a language needing utf-8 for the manager interface, the
//default encoding will of course be utf-8

if (empty($_SESSION['step2'])) {
	header('Location: check.php');
	exit;
}

//load the language file
$_PX_config['encoding'] = $_SESSION['encoding'];
$l = new l10n($_SESSION['lang'], 'install');

$manager_langs = l10n::getAvailableLocales();
$western_langs = l10n::getIsoWestern();
$isocodes      = l10n::getIsoCodes();


$mlangs = array(); //list of languages for the manager
$wlangs = array(); //list of western languages

$propose_encoding = true;
if ($_SESSION['encoding'] == 'utf-8') {
	$propose_encoding = false; //will be utf-8 as the user "likes" non western languages up to
							   // have the installer in a non western language
}

reset($manager_langs);
foreach ($manager_langs as $iso) {
	$mlangs[$isocodes[$iso]] = $iso;
}

reset($western_langs);
foreach ($western_langs as $iso) {
	$wlangs[] = $isocodes[$iso];
}

if (!empty($_POST['mlang'])) {
	$manager_encoding = 'utf-8';
	if (!empty($_POST['encoding'])) {
		$manager_encoding = $_POST['encoding'];
	}
	if ($manager_encoding != 'utf-8' && !in_array($_POST['mlang'], $western_langs)) {
		// the user said, he doesn't want more than western languages but selected a
		// non western for the default manager language! Switch to utf-8
		$manager_encoding = 'utf-8';
	}
	$_SESSION['manager_encoding'] = $manager_encoding;
	$_SESSION['manager_lang'] = $_POST['mlang'];
	$_SESSION['step3'] = true;
	header('Location: dbinfo.php');
	exit;
}



include dirname(__FILE__).'/_top.php';

echo '<form action="encoding.php" method="post" id="formPost">'."\n\n";

if ($propose_encoding) {
	echo '<h2>'.__('Languages used in the content of your site').'</h2>'."\n\n";

	echo '<p>'.__('Do you want to have more than the Western Europe languages listed below in the content of your sites?').'</p>'."\n\n";

	echo '<p><strong>'.__('Western Europe languages').'</strong></p>'."\n\n";

	echo '<ul id="langs">'."\n";
	foreach ($wlangs as $lg) {
		echo '<li>'.$lg.'</li>'."\n";
	}
	echo '</ul>'."\n";
	?>
	<p class="field">
	<label class="float" for="encoding" style="display:inline"><?php  echo __('Languages:'); ?></label>
	<?php echo php_f_combobox('encoding', array(__('I just need the Western Europe languages (encoding iso-8859-1)') => 'iso-8859-1', __('I need more languages like Japanese (encoding utf-8)') => 'utf-8'), 'iso-8859-1');  ?>
	</p>
	<?php
}

echo '<h2>'.__('Default language for the manager').'</h2>'."\n\n";

echo '<p>'.__('The default language of the manager is the one the users entering the manager for the first time will see. At any time they can change it in their preferences.').'</p>'."\n\n";
?>
<p class="field">
<label class="float" for="mlang" style="display:inline"><?php  echo __('Default manager language:'); ?></label>
<?php echo php_f_combobox('mlang', $mlangs, $_SESSION['lang']);  ?>
<input name="next" type="submit" class="submit" value="<?php  echo __('Next'); ?>"  accesskey="n" />
</p>
</form>
<?php

include dirname(__FILE__).'/_bottom.php';

?>
