<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
require_once dirname(__FILE__).'/prepend.php';

$_px_p = 0; //percentage of wizard done.

/*
Overview of the steps.

1- Chose language for installation and/or interface -> go to 9bis if update
2- Check
3- Chose encoding if needed and language for the interface
4- Database info
5- Database install
6- First user
7- First website
8- First post
9- Secure installer
9bis- Update
10- Go to the admin
*/

$installer_langs = l10n::getAvailableLocales('', 'install');
$install_lang = l10n::getAcceptedLanguage($installer_langs);

$update = false;
//Check if a global config file is available
if (file_exists($_PX_config['manager_path'].'/conf/config.php')) {
	include_once $_PX_config['manager_path'].'/conf/config.php';
	//overwrite install lang
	$install_lang = $_PX_config['lang'];
	$update = true;
	$_SESSION['step1'] = true;
}

//Check if language selected.

if (!empty($_POST['lang'])) {
	if (in_array($_POST['lang'], $installer_langs)) {
		if (in_array($_POST['lang'], l10n::getIsoWestern())) {
			$_SESSION['encoding'] = 'iso-8859-1';
		} else {
			$_SESSION['encoding'] = 'utf-8';
		}
		$_SESSION['lang'] = $_POST['lang'];
		$_SESSION['step1'] = true;
		header('Location: check.php');
		exit;
	}
}

//load the language file
if (!empty($_PX_config['encoding'])) {
	$_SESSION['encoding'] = $_PX_config['encoding'];
} elseif (in_array($install_lang, l10n::getIsoWestern())) {
	$_PX_config['encoding'] = 'iso-8859-1';
} else {
	$_PX_config['encoding'] = 'utf-8';
}
$l = new l10n($install_lang, 'install');

//Populate the list of languages
$isocodes = $l->getIsoCodes();
$langs = array();
reset($installer_langs);
foreach ($installer_langs as $iso) {
	$langs[$isocodes[$iso]] = $iso;
}

include dirname(__FILE__).'/_top.php';


echo '<h2>'.__('Welcome on the PLUME CMS installation').'</h2>'."\n\n";

if ($update) {
	echo '<p>'.sprintf(__('A possible previous installation of PLUME CMS is detected. You are invited to <a href="%s">upgrade your installation</a>.'), 'upgrade.php').'</p>';
} else {
	echo '<p>'.__('Please chose the language of the installation wizard.').'</p>'."\n\n";
	?>
	<form action="index.php" method="post" id="formPost">
		<p class="field">
		<label class="float" for="lang" style="display:inline"><?php  echo __('Language:'); ?></label>
		<?php echo php_f_combobox('lang', $langs, $install_lang);  ?>
		<input name="next" type="submit" class="submit" value="<?php  echo __('Next'); ?>"  accesskey="n" />
  		</p>
	</form>
	<?php
}

include dirname(__FILE__).'/_bottom.php';
?>
