<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
require_once dirname(__FILE__).'/prepend.php';

$_px_p = 100; //percentage of wizard done.

if (empty($_SESSION['step1'])) {
	header('Location: index.php');
	exit;
}
include_once $_PX_config['manager_path'].'/conf/config.php';
$l = new l10n($_PX_config['lang'], 'install');


$checklist = new checklist();


//-- Update of the main configuration file --//
$file = dirname(__FILE__).'/../conf/config.php';
$cfg = new configfile($file);
$cfg->prefix = '_PX_config';
$test = true;
$b_mess = $g_mess = '';
if ($cfg->addVar('encoding', (string) 'iso-8859-1', 'Encoding of the pages in all PLUME CMS.')) {
	$g_mess = __('The encoding configuration variable has been added to the configuration file.');
	$update = true;
} else {
	$g_mess = __('The encoding configuration variable is already set in the configuration file.');
	$update = false;
}
if ($update && !$cfg->saveFile()) {
	$b_mess = __('Impossible to set the encoding configuration variable in the configuration file.');
	$test = false;
}
$checklist->addTest('encoding', $test, $g_mess, $b_mess);

$cfg = new configfile($file);
$cfg->prefix = '_PX_config';
$test = true;
$b_mess = $g_mess = '';
if ($cfg->addVar('log404errors', (bool) false, 'Create a log of the 404 errors')) {
	$g_mess = __('The 404 error logging configuration variable has been added to the configuration file.');
	$update = true;
} else {
	$g_mess = __('The 404 error logging configuration variable is already set in the configuration file.');
	$update = false;
}
if ($update && !$cfg->saveFile()) {
	$b_mess = __('Impossible to set the 404 error logging configuration variable in the configuration file.');
	$test = false;
}
$checklist->addTest('log404errors', $test, $g_mess, $b_mess);

$cfg = new configfile($file);
$cfg->prefix = '_PX_config';
$test = true;
$b_mess = $g_mess = '';
if ($cfg->addVar('article_textarea_page', (string) '15', 'Default size of the textarea when adding a page')) {
	$g_mess = __('The default size of the page textarea has been added to the configuration file.');
	$update = true;
} else {
	$g_mess = __('The default size of the page textarea is already set in the configuration file.');
	$update = false;
}
if ($update && !$cfg->saveFile()) {
	$b_mess = __('Impossible to set the default size of the page textarea in the configuration file.');
	$test = false;
}
$checklist->addTest('article_textarea_page', $test, $g_mess, $b_mess);

$cfg = new configfile($file);
$cfg->prefix = '_PX_config';
$test = true;
$b_mess = $g_mess = '';
if ($cfg->addVar('article_textarea_description', (string) '7', 'Default size of the description textarea of an article')) {
	$g_mess = __('The default size of the article description textarea has been added to the configuration file.');
	$update = true;
} else {
	$g_mess = __('The default size of the article description textarea is already set in the configuration file.');
	$update = false;
}
if ($update && !$cfg->saveFile()) {
	$b_mess = __('Impossible to set the default size of the article description textarea in the configuration file.');
	$test = false;
}
$checklist->addTest('article_textarea_description', $test, $g_mess, $b_mess);

$cfg = new configfile($file);
$cfg->prefix = '_PX_config';
$test = true;
$b_mess = $g_mess = '';
if ($cfg->addVar('news_textarea_content', (string) '12', 'Default size of the content textarea of a news')) {
	$g_mess = __('The default size of the news content textarea has been added to the configuration file.');
	$update = true;
} else {
	$g_mess = __('The default size of the news content textarea is already set in the configuration file.');
	$update = false;
}
if ($update && !$cfg->saveFile()) {
	$b_mess = __('Impossible to set the default size of the news content textarea in the configuration file.');
	$test = false;
}
$checklist->addTest('news_textarea_content', $test, $g_mess, $b_mess);

$cfg = new configfile($file);
$cfg->prefix = '_PX_config';
$test = true;
$b_mess = $g_mess = '';
if ($cfg->addVar('category_textarea', (string) '7', 'Default size of the description of a category')) {
	$g_mess = __('The default size of the category description textarea has been added to the configuration file.');
	$update = true;
} else {
	$g_mess = __('The default size of the category description textarea is already set in the configuration file.');
	$update = false;
}
if ($update && !$cfg->saveFile()) {
	$b_mess = __('Impossible to set the default size of the category description textarea in the configuration file.');
	$test = false;
}
$checklist->addTest('category_textarea', $test, $g_mess, $b_mess);


//-- Copy the 404.php template if needed for each website --//
$u = new User(1); //rootuser
$m = new Manager();
$m->setUser($u);
$test = true;
if (($webs = $m->getSites()) !== false) {
	$src = dirname(__FILE__).'/../templates/_dist/default/templates/404.php';
	while (!$webs->EOF()) {
		$dest = dirname(__FILE__).'/../templates/'.$webs->f('website_id').'/404.php';
		$copy = files::copyfile($src, $dest);
		if (files::is_success($copy)) {
			$w_mess = '';
			$g_mess = sprintf(__('Copy of the template <em>%s</em> to <em>%s</em>'), files::real_path($src), files::real_path($dest));
			$test = true;
		} else {
			$g_mess = '';
			$w_mess = sprintf(__('Error in the copy of the template <em>%s</em> to <em>%s</em>'), files::real_path($src), files::real_path($dest));
			$test = 2;
		}
		$checklist->addTest('404template'.$webs->f('website_id'), $test, $g_mess, '', $w_mess);
		$webs->moveNext();
	}
} else {
	$test = 2;
	$w_mess = __('Unable to get the list of websites to copy the new 404.php template. Please do it manually.');
	$checklist->addTest('404template', $test, '', '', $w_mess);
}


//-- Upgrade of the database --//
$con = pxDBConnect();
$xml = implode("\n", file('./db-upgrade.xml'));
$sql = new xmlsql($con, $xml);

//-- MySQL version --//
$rsV = $con->select('SELECT VERSION() AS version');
$mysql_version = preg_replace('/-log$/','',$rsV->f(0));
$extra = '';
if (version_compare($mysql_version, '3.23', '>=')) {
    $extra = 'TYPE=MyISAM';
}

$sql->replace('{{TYPE}}', $extra);
$sql->replace('{{PREFIX}}',$_PX_config['db']['table_prefix']);
$sql->execute($checklist);

$check = $checklist->checkAll();
$m->user->logout();

include dirname(__FILE__).'/_top.php';

echo '<h2>'.__('Upgrade of the installation').'</h2>'."\n\n";

if ($check) {
	echo '<h3>'.__('Congratulations, PLUME CMS has been upgraded!').'</h3>'."\n\n";
} else {
    echo "\n\n" .'<p class="important">'. __('Some errors occured during the upgrade procedure. Please check carefully the messages to see if you need to finish the upgrade manually.') .'</p>'. "\n\n";
}

echo $checklist->getHtml('../themes/default/images');

echo '<p>'.sprintf(__('You can now access the manager. <a href="%s">Access the manager</a>.'), '../login.php?logout=1').'</p>'."\n";

include dirname(__FILE__).'/_bottom.php';
?>
