<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';

if (!empty($_GET['logout'])) {
    $_SESSION = array();
	$_SESSION['user_id'] = '';
	$_SESSION['webs'] = array();
	header('Location: index.php');
    exit;
}


$errorinlogin = false;
$website = '';
if (isset($_POST['username']) && isset($_POST['password'])) {
    if (!empty($_COOKIE['website_id'])) $website = $_COOKIE['website_id'];
    if (authLogin($_POST['username'], $_POST['password'], PX_AUTH_NORMAL, $website)) {
        header('Location: index.php');
        exit;
    } 
    $errorinlogin = true;
    $_COOKIE['website_id'] = '';
}
if (isset($_POST['username'])) $px_username = textSecureString($_POST['username']);
else $px_username = '';
$px_password = '';

if (empty($_POST['username']) && !empty($_GET['username'])) $px_username = textSecureString($_GET['username']);
if (empty($_POST['password']) && !empty($_GET['password'])) $px_password = textSecureString($_GET['password']);

$locales = l10n::getAvailableLocales();

if (!empty($_COOKIE['lang']) && in_array($_COOKIE['lang'], $locales)) $lang = $_COOKIE['lang'];
else $lang = l10n::getAcceptedLanguage($locales);

$l = new l10n($lang);

// Here you can consider that username/password was not good, or not given.
header('Content-Type: text/html; charset='.strtolower($GLOBALS['_PX_config']['encoding']));
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>PLUME CMS</title>
  <link rel="stylesheet" type="text/css" href="themes/default/style.css" />
  <meta http-equiv="Content-Type" content="text/html; charset=<?php echo strtolower($GLOBALS['_PX_config']['encoding']); ?>" />
</head>
<body>


<div style="text-align:center;">
<h1><img src="themes/default/images/logo.png" alt="PLUME CMS" /></h1>

<form action="login.php" method="post">
<div class="login">
<?php
if ($errorinlogin)
{
	echo '<p><strong>'.__('There is an error with your login or your password.').'</strong></p>';
    $px_password = '';
}
?>


<p><label for="username"><strong><?php echo __('Login:'); ?></strong></label>
<input name="username" id="username" type="text" maxlength="32"
value="<?php echo $px_username; ?>" tabindex="1"/></p>

<p><label for="password"><strong><?php echo __('Password:'); ?></strong></label>
<input name="password" id="password" type="password" value="<?php echo $px_password; ?>" tabindex="2" /></p>

<p><input class="submit" type="submit" value="<?php echo __('Ok'); ?>" /></p>

<p><?php echo __('You need to accept the cookies to access the manager.'); ?></p>

</div>
</form>
</div>

</body>
</html>
