<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_NORMAL, (!empty($_SESSION['website_id']))?$_SESSION['website_id']:'');

/*=================================================
 Create the manager object, load the libs and class
=================================================*/
require_once $_PX_config['manager_path'].'/inc/class.news.php';

$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

$news = new News();
$is_user_admin = authAsLevel(PX_AUTH_ADMIN, $_SESSION['website_id']);
/*=================================================
 Get some info of the current step for the submenu
=================================================*/
// display 'add news' menu?
if (!empty($_REQUEST['op']) || empty($_REQUEST['resource_id'])) $display_add_news = true;
else $display_add_news = false;

$px_submenu->addItem( __('Back to the list of resources'), 'index.php', 'themes/'.$_px_theme.'/images/ico_back.png',     false);
$px_submenu->addItem( __('News list'), 'news.php?op=list', 'themes/'.$_px_theme.'/images/ico_news.png', false);
$px_submenu->addItem( __('New news'),  'news.php',  'themes/'.$_px_theme.'/images/ico_new.png', false, $display_add_news);


/*==============================================================================
 Process block
==============================================================================*/

if (empty($_REQUEST['op'])): // add/edit/view a news


/*=================================================
 Set all the default values
=================================================*/
$px_news_id             = '';
$px_news_title          = '';
$px_news_content        = '';
$px_news_titlewebsite   = '';
$px_news_linkwebsite    = '';
$px_news_subject        = '';
$px_news_content_format = $m->user->getPref('content_format');
$px_news_status         = ($m->user->getPref('news_status')) ? $m->user->getPref('news_status') : PX_RESOURCE_STATUS_INEDITION;
$px_news_noenddate      = 1;
$px_news_category_id    = $m->user->getPref('news_category_id');
$news_ts                = time();
$px_news_categories     = new recordset();
$px_news_textarea = $m->user->getPref('news_textarea_content');

// start date
$dt_y = date('Y',$news_ts);
$dt_m = date('m',$news_ts);
$dt_d = date('d',$news_ts);
$dt_h = (string) date('H',$news_ts);
$dt_i = (string) date('i',$news_ts);
$dt_s = (string) date('s',$news_ts);
// end date
$dt_e_y = '9999';
$dt_e_m = '12';
$dt_e_d = '31';
$dt_e_h = '23';
$dt_e_i = '59';
$dt_e_s = '59';
$px_news_enddate = $dt_e_y.'-'.$dt_e_m.'-'.$dt_e_d.' '.$dt_e_h.':'.$dt_e_i.':'.$dt_e_s;
$px_news_pubdate = $dt_y.'-'.$dt_m.'-'.$dt_d.' '.$dt_h.':'.$dt_i.':'.$dt_s;
$px_news_subtype = $m->user->getPref('news_subtype');
$subtypes = $m->getSubTypes('','news');
$arry_subtypes = array();
$arry_subtypes_extra = array();
if ($subtypes->nbRow() == 0) {
	$m->setError(sprintf( __('You need to <a href="%s">add 2 types of resource</a>, one for the articles and one for the news.'), 'subtypes.php?op=add'), 500);
}
while (!$subtypes->EOF()) {
    $arry_subtypes[$subtypes->f('subtype_name')] = $subtypes->f('subtype_id');
    if (1 == $subtypes->f('subtype_extra1')) {
        $arry_subtypes_extra[] =  $subtypes->f('subtype_id');
    } 
    $subtypes->moveNext();    
}
    
/*=================================================
 Get current news and check if right to edit it
=================================================*/
$is_editable = true;
if (!empty($_REQUEST['resource_id'])) {
    if ((($news = $m->getResourceByIdentifier($_REQUEST['resource_id'], 'News')) !== false) 
        && $news->f('type_id') == 'news' && $news->f('website_id') == $m->user->website) {
        // check the rights
        if ((authAsLevel(PX_USER_LEVEL_ADVANCED, $news->f('website_id'))
           || ($news->f('user_id') == $m->user->user['user_id'] && $news->f('status') != PX_RESOURCE_STATUS_VALIDE))
             ) {         
            // ok for edition
            $is_editable = true;
            $px_news_id           = $news->f('resource_id');            
            $px_news_title        = $news->f('title');
            $px_news_content      = textGetRawContent($news->f('description'));
            $px_news_titlewebsite = $news->f('news_titlewebsite');
            $px_news_linkwebsite  = $news->f('news_linkwebsite');
            $px_news_subject      = $news->f('subject');
            $px_news_categories   = $news->getCategories();
            $px_news_subtype      = $news->f('subtype_id');
            // $px_news_catids       = $px_news_categories->getIDs('', 'category_id');
            $px_news_content_format = ( ($type = textGetType($news->f('description'))) !== false) ? $type : $m->user->getPref('content_format');
            $px_news_status       = $news->f('status');
            list($dt_h,   $dt_i,   $dt_s,   $dt_m,   $dt_d,   $dt_y)   = explodeDate($news->f('publicationdate'));
            list($dt_e_h, $dt_e_i, $dt_e_s, $dt_e_m, $dt_e_d, $dt_e_y) = explodeDate($news->f('enddate'));
            $px_news_noenddate = ($dt_e_y == 9999); /** @todo bug to fix in year 9999 :o) */

        } else {
            $px_news_title          = $news->f('title');
            $px_news_content        = textGetRawContent($news->f('description'));
            $px_news_content_format = ( ($type = textGetType($news->f('description'))) !== false) ? $type : $m->user->getPref('content_format');
            $is_editable = false;
        }
        $details = $news->getDetails();
        $px_news_titlewebsite   = $details->f('news_titlewebsite');
        $px_news_linkwebsite    = $details->f('news_linkwebsite'); 
            
    } else {
        $m->setError( __('Error: The requested news is not available.'), 400);
        $is_editable = false;
    }
}
/*=================================================
 No news, set default values or from preview
=================================================*/
# Valeurs pour la prvisualisation, la cration ou la modification d'un billet
if ((!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform']) || !empty($_POST['addcategory'])
	|| !empty($_POST['increase']) || !empty($_POST['increase_x']) || !empty($_POST['decrease']) || !empty($_POST['decrease_x'])
	)
    && $is_editable) {
    $px_news_title          = $_POST['n_title'];
    $px_news_content        = $_POST['n_content'];
    $px_news_titlewebsite   = (!empty($_POST['n_titlewebsite'])) ? $_POST['n_titlewebsite'] : '';
    $px_news_linkwebsite    = (!empty($_POST['n_linkwebsite'])) ? $_POST['n_linkwebsite'] : '';
    $px_news_subject        = $_POST['n_subject'];
    $px_news_content_format = $_POST['n_content_format'];
    $px_news_status         = $_POST['n_status'];
    $px_news_category_id    = $_POST['n_category_id'];
    $px_news_noenddate      = (!empty($_POST['n_noenddate']));
    $px_news_subtype        = $_POST['n_subtype'];

	if (!empty($_POST['increase']) || !empty($_POST['increase_x'])) {
		$px_news_textarea = $m->user->increase('news_textarea_content');
	}
	if (!empty($_POST['decrease']) || !empty($_POST['decrease_x'])) {
		$px_news_textarea = $m->user->decrease('news_textarea_content');
	}

	if (!empty($px_news_id))
	{
		$dt_y = (string) sprintf('%04d',$_POST['n_dt_y']);
		$dt_m = (string) sprintf('%02d',$_POST['n_dt_m']);
		$dt_d = (string) sprintf('%02d',$_POST['n_dt_d']);
		$dt_h = (string) sprintf('%02d',$_POST['n_dt_h']);
		$dt_i = (string) sprintf('%02d',$_POST['n_dt_i']);
		$dt_s = (string) sprintf('%02d',$_POST['n_dt_s']);

		# Corrections jour & heure
		if ($dt_d > 31 || $dt_d < 1) { $dt_d = '01'; }
		if ($dt_h > 23 || $dt_h < 0) { $dt_h = '00'; }
		if ($dt_i > 59 || $dt_i < 0) { $dt_i = '00'; }
		if ($dt_s > 59 || $dt_s < 0) { $dt_s = '00'; }

        if (!$px_news_noenddate) {
    		$dt_e_y = (string) sprintf('%04d',$_POST['n_dt_e_y']);
    		$dt_e_m = (string) sprintf('%02d',$_POST['n_dt_e_m']);
    		$dt_e_d = (string) sprintf('%02d',$_POST['n_dt_e_d']);
    		$dt_e_h = (string) sprintf('%02d',$_POST['n_dt_e_h']);
    		$dt_e_i = (string) sprintf('%02d',$_POST['n_dt_e_i']);
    		$dt_e_s = (string) sprintf('%02d',$_POST['n_dt_e_s']);
    		
    		# Corrections jour & heure
    		if ($dt_e_d > 31 || $dt_e_d < 1) { $dt_e_d = '01'; }
    		if ($dt_e_h > 23 || $dt_e_h < 0) { $dt_e_h = '00'; }
    		if ($dt_e_i > 59 || $dt_e_i < 0) { $dt_e_i = '00'; }
    		if ($dt_e_s > 59 || $dt_e_s < 0) { $dt_e_s = '00'; }
        } else {
    		$dt_e_y = '9999';
    		$dt_e_m = '12';
    		$dt_e_d = '31';
    		$dt_e_h = '23';
    		$dt_e_i = '59';
    		$dt_e_s = '59';
        }        
        $px_news_enddate = $dt_e_y.'-'.$dt_e_m.'-'.$dt_e_d.' '.$dt_e_h.':'.$dt_e_i.':'.$dt_e_s;
        $px_news_pubdate = $dt_y.'-'.$dt_m.'-'.$dt_d.' '.$dt_h.':'.$dt_i.':'.$dt_s;
	}
	
	if (!empty($_POST['transform'])) {
        $px_news_content = textParseContent("=$px_news_content_format\n".$px_news_content);
        $px_news_content_format = 'html';
	}
} elseif (!empty($_GET['n_category_id'])) {
    $px_news_category_id    = $_GET['n_category_id'];
}    

/*=================================================
 Add, edit a news
=================================================*/
if (!empty($_POST['publish']) && $is_editable) {
    if (!empty($px_news_id)) {
        // edit
        $news->set($px_news_title, $px_news_subject, $px_news_content, $px_news_content_format, $px_news_status, 
                    $px_news_pubdate, $px_news_enddate, !$px_news_noenddate, $px_news_subtype);
        $news->setDetails($px_news_titlewebsite, $px_news_linkwebsite);      
        if (false !== ($id = $m->updNews($news))) { 
            if ($px_news_status != PX_RESOURCE_STATUS_INEDITION) { 
                $msg =  __('The news was successfully saved.');    
                header('Location: news.php?op=list&msg='.urlencode($msg));
            } else
                header('Location: news.php?resource_id='.$id);
            exit;
        }                             
    } else {
    	$m->user->savePref('news_category_id', $px_news_category_id, $_SESSION['website_id']);
    	$m->user->savePref('news_status', $px_news_status, $_SESSION['website_id']);
    	$m->user->savePref('content_format', $px_news_content_format, $_SESSION['website_id']);
    	$m->user->savePref('news_subtype', $px_news_subtype, $_SESSION['website_id']);
        $news->set($px_news_title, $px_news_subject, $px_news_content, $px_news_content_format, $px_news_status, 
                    $px_news_pubdate, $px_news_enddate, !$px_news_noenddate, $px_news_subtype, $px_news_category_id, $_SESSION['website_id'], $m->user->user['user_id']);
        $news->setDetails($px_news_titlewebsite, $px_news_linkwebsite);      
        if (false !== ($id = $m->addNews($news))) {     
            if ($px_news_status != PX_RESOURCE_STATUS_INEDITION) {
                $msg =  __('The news was successfully saved.');    
                header('Location: news.php?op=list&msg='.urlencode($msg));
            } else
                header('Location: news.php?resource_id='.$id);
            exit;
        }  
    }
}

if (!empty($_REQUEST['addcategory']) && !empty($px_news_id) && $is_editable) {
	$m->user->savePref('news_category_id', $px_news_category_id, $_SESSION['website_id']);
    $type = ('main' == $_REQUEST['addcategory']) ? PX_RESOURCE_CATEGORY_MAIN : PX_RESOURCE_CATEGORY_OTHER ; 
    if (false !== $m->addResourceInCategory($px_news_id, $px_news_category_id, $type)) {
        header('Location: news.php?resource_id='.$px_news_id);
        exit;
    }
}

if (!empty($_GET['delcat']) && !empty($px_news_id) && $is_editable) {
    if (false !== $m->removeResourceFromCategory($px_news_id, $px_news_category_id)) {
        header('Location: news.php?resource_id='.$px_news_id);
        exit;
    }
}

if (!empty($_POST['delete']) && $is_editable) {
    if ($m->delNews($px_news_id) !== false) {
        $msg =  __('The news was successfully deleted.');
        header('Location: news.php?op=list&msg='.urlencode($msg));
        exit;
    }
}

/*=================================================
 Get the categories for the news, array of status
 array for the dates
=================================================*/
if ($is_editable) {
	$arry_cat = $m->getArrayCategories();
    // Status
    $arry_status[ __('In edition')]     = PX_RESOURCE_STATUS_INEDITION;
    $arry_status[ __('Waiting for validation')] = PX_RESOURCE_STATUS_TOBEVALIDATED;
    if (authAsLevel(PX_USER_LEVEL_ADVANCED, $_SESSION['website_id']))
        $arry_status[ __('On-line')]    = PX_RESOURCE_STATUS_VALIDE;
    $arry_status[ __('Off-line')]       = PX_RESOURCE_STATUS_OFFLINE;   
    

    // Table of the months
    for ($i=1; $i<=12; $i++) {
    	$month = sprintf('%02d', $i);
    	$arry_dt_m[if_utf8(strftime('%B', strtotime('2000-'.$month.'-01')))] = $month;
    }

}
endif; // add/edit/view a news

/*=================================================
 list news
=================================================*/
if (!empty($_REQUEST['op']) && 'list' == $_REQUEST['op']):

//Get the category id and save it
$cat_id = (!empty($_GET['cat_id'])) ? $_GET['cat_id'] : $m->user->getPref('list_news_cat_id');
$m->user->savePref('list_news_cat_id', $cat_id, $_SESSION['website_id'], true);
if ($cat_id == 'allcat') $cat_id = '';

//Get the search query
$px_q = (!empty($_GET['q'])) ? $_GET['q'] : '';

//Get available months and selected
list($first, $last, $arry_months) = $m->getArrayMonths('news', $cat_id);
$px_m_s = $m->user->getPref('list_news_month');
$px_m = (!empty($_GET['m'])) ? $_GET['m'] : ((!empty($px_m_s)) ? $px_m_s : $last);
$m->user->savePref('list_news_month', $px_m, $_SESSION['website_id'], true);

if ($px_m == 'alldate') {
    $px_m = $first;
    $px_end   =  timestamp(0, 1 /*1 month after now*/, 0);
} else {
    $px_end   =  timestamp(0, 1 /*1 month after $px_m */, 0, makeTime($px_m));
}

if (empty($px_q)) {
	$res = $m->getResources(''/* All users */, '' /* All status */, $cat_id, 'news', $px_m /*Date start */, $px_end /*Date end */);
	//get again as possibly modified because of the 'alldate' case
	$px_m = $m->user->getPref('list_news_month');
} else {
	$res = $m->searchResources($px_q, false /*Not only the online resources */, 'news', 'News' /*Class used for the results */);
	//Search is made on all the date and all the categories
	$px_m = 'alldate';
	$cat_id = 'allcat';
}

// Categories
$arry_cat = $m->getArrayCategories(true);

endif;

/*==============================================================================
 Display block
==============================================================================*/

/*=================================================
 Set title of the page, and load common top page
=================================================*/
$px_title =  __('News');
include $_PX_config['manager_path'].'/mtemplates/_top.php';

echo '<h1>'. __('News')."</h1>\n\n";

/*=================================================
 add/edit/view a news
=================================================*/
if (empty($_REQUEST['op'])):


/*=================================================
 Preview of the content if some content is available
=================================================*/
if (strlen($px_news_content)) {
    echo '<div class="preview">';
    
    if (!empty($_POST['preview']) || !empty($_POST['publish']) || !empty($_POST['transform']))
        $px_news_title_preview = textSecureString($px_news_title);
    else $px_news_title_preview = $px_news_title;
        
    echo '<h3>'.$px_news_title_preview.'</h3>';
    echo textParseContent("=$px_news_content_format\n".$px_news_content);
    echo "<hr class='invisible' id=\"zoubida\" /></div>\n\n";
}
/*=================================================
 If is editable form to modify the content
=================================================*/
?>
<?php if ($is_editable) : ?>
  <form action="news.php" method="post" id="formPost" onsubmit="return isReady('n_title','<?php echo __('You need to give a title.') ?>')">
  <?php echo '<script type="text/javascript">'."\n".
		"<!--\n".
		"var js_subtype_ids = new Array('".implode("','",$arry_subtypes_extra)."');\n".
		"//-->\n".
		"</script>\n";
  ?>      
  
  <?php 
    if ($px_news_categories->nbRow() >= 1) {
        echo '<fieldset><legend>'. __('Categories')."</legend>\n\n";
        echo "<ol>\n";
        while (!$px_news_categories->EOF()) {
            echo '<li>'.$px_news_categories->f('category_name');
            if ($px_news_categories->f('categoryasso_type') != PX_RESOURCE_CATEGORY_MAIN) {
                echo ' - <a href=\'news.php?delcat=1&amp;resource_id='.$px_news_id.'&amp;n_category_id='.$px_news_categories->f('category_id').'\' title=\''. __('Remove from this category').'\'>';
                echo '<img src="themes/'.$_px_theme.'/images/delete.png" alt=" "></a> ';
                echo ' <a href=\'news.php?addcategory=main&amp;resource_id='.$px_news_id.'&amp;n_category_id='.$px_news_categories->f('category_id').'\' title=\''. __('Set as main category').'\'>';
                echo '<img src="themes/'.$_px_theme.'/images/ico_set_as_home.png" alt=" "></a> ';
            } else {
                echo ' - <img src="themes/'.$_px_theme.'/images/ico_home.png" alt="'. __('Main category').'"></a>';
            }
            echo "</li>\n";
            $px_news_categories->moveNext();
        }
        echo "</ol>\n\n";
  ?>
  <p>
  <span class="nowrap"><label for="n_category_id"
  style="display:inline"><?php  echo __('Add in another category'); ?>  <?php $m->HelpLink('news', 'h-category'); ?></label><br />
  <?php echo php_f_combobox('n_category_id',$arry_cat, '', 1); ?>
  <input name="addcategory" tabindex="2" type="submit" class="submit" value="<?php  echo __('Add'); ?>" />
  </span></p>
  </fieldset>
  <p>
  <?php      
  
    } else {
  ?>
  <p>
  <span class="nowrap"><label for="n_category_id"
  style="display:inline"><?php  echo __('Category'); ?> <?php $m->HelpLink('news', 'h-category'); ?></label>
  <?php echo php_f_combobox('n_category_id', $arry_cat, $px_news_category_id, 2); ?></span>
  <?php 
    } // end off no category for the moment
   ?>
  <span class="nowrap"><label for="n_content_format"
  style="display:inline"><?php  echo __('Format'); ?>  <?php $m->HelpLink('news', 'h-format'); ?></label>
  <?php
  echo php_f_combobox('n_content_format',array('HTML'=>'html','Wiki'=>'wiki'),$px_news_content_format, 3);
  ?></span>
  
  <span class="nowrap"><label for="n_status"
  style="display:inline"><?php  echo __('Status'); ?> <?php $m->HelpLink('news', 'h-status'); ?></label>
  <?php
  echo php_f_combobox('n_status', $arry_status, $px_news_status,4);
  ?></span>

<?php if (count($arry_subtypes) > 1) { ?>
  <span class="nowrap"><label for="n_subtype"
  style="display:inline"><?php  echo __('Type'); ?> <?php $m->HelpLink('news', 'h-type'); ?></label>
  <?php echo php_f_combobox('n_subtype', $arry_subtypes, $px_news_subtype, 5,'',"onChange=\"openCloseBlockIfArray('div_extra','n_subtype',js_subtype_ids,1,-1)\";"); ?>
  </span>
  </p>
<?php } else {
	echo php_f_hidden('n_subtype', array_shift($arry_subtypes));
} ?>

  <p><label for="n_title"><strong><?php  echo __('Title'); ?></strong> <?php $m->HelpLink('news', 'h-title'); ?></label>
  <?php echo php_f_textField('n_title', 30, 255, $px_news_title, 6, 'style="width:100%"'); ?>
  </p>

  <p>
  <span class="bloc-droite"><img src="themes/<?php echo $_px_theme; ?>/images/ico_image.png" alt="" />
  <strong><a href="xmedia.php" accesskey="i"
  onclick="popup(this.href+'?mode=popup'); return false;"><?php  echo __('Insert an image or a file'); ?></a></strong></span>
  <label for="n_content"><strong><?php  echo __('Content of the news'); ?></strong> <?php $m->HelpLink('news', 'h-content'); ?></label>
  <?php
  echo php_f_textArea('n_content',60,$px_news_textarea,
  		htmlspecialchars($px_news_content),7,'style="width:100%"');
  ?>
   <span class="size-control">
   <input type="image" alt="<?php echo __('shrink textarea'); ?>" name="decrease" value="<?php  echo '-'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_shrink.png" accesskey="-" class="size-control" />
   <input type="image" alt="<?php echo __('grow textarea'); ?>" name="increase" value="<?php  echo '+'; ?>" src="themes/<?php echo $_px_theme; ?>/images/ico_grow.png" accesskey="+" class="size-control" />
   </span>
  </p>

  <p><label for="n_subject"><?php  echo __('Keywords'); ?> <?php $m->HelpLink('news', 'h-keywords'); ?></label>
  <?php
  echo php_f_textArea('n_subject',60,4,
  		htmlspecialchars($px_news_subject), 8,'style="width:100%"');
  ?>
  </p>

  <div id='div_extra'>
  <p><label for="n_titlewebsite"><?php  echo __('Associated website title'); ?> <?php $m->HelpLink('news', 'h-asso-title'); ?></label>
  <?php echo php_f_textField('n_titlewebsite', 50, 255, $px_news_titlewebsite, 9, 'style="width:100%"'); ?>
  </p>
  <p><label for="n_linkwebsite"><?php  echo __('Associated website address'); ?> <?php $m->HelpLink('news', 'h-asso-address'); ?></label>
  <?php echo php_f_textField('n_linkwebsite', 50, 255, $px_news_linkwebsite, 10, 'style="width:100%"'); ?>
  </p>
  </div>

  <script type="text/javascript">
    <!--
    openCloseBlockIfArray('div_extra','n_subtype',js_subtype_ids,1,-1);
    //-->
  </script>


  <?php
  if (!empty($px_news_id))
  {
	echo '<p>'. __('Publication date').' ';
	$m->HelpLink('news', 'h-publication-date');
	echo ' '.php_f_textField('n_dt_d',2,2,$dt_d,11).' '.
		php_f_combobox('n_dt_m',$arry_dt_m,$dt_m,11).' '.
		php_f_textField('n_dt_y',4,4,$dt_y,11).' '.
		 __('Time:').' '.
		php_f_textField('n_dt_h',2,2,$dt_h,11).':'.
		php_f_textField('n_dt_i',2,2,$dt_i,11).':'.
		php_f_textField('n_dt_s',2,2,$dt_s,11).
		"<br />\n";
        $noenddate_style = ($px_news_noenddate) ? 'style="display: none"' : '';

    echo '<span class="nowrap">'.php_f_checkbox('n_noenddate', 1, $px_news_noenddate,12, "onclick=\"openCloseSpan('noenddate',0)\"; return false;").' '.
        '<label for="n_noenddate" style="display:inline">'. __('Do not use an expiration date.').'</label></span>'.
        ' <span class="nowrap" id="noenddate" '.$noenddate_style.'><br />'. __('Expiration date').' ';
    $m->HelpLink('news', 'h-expiration-date');
    echo ' '.php_f_textField('n_dt_e_d',2,2,$dt_e_d,13).' '.
		php_f_combobox('n_dt_e_m',$arry_dt_m,$dt_e_m,13).' '.
		php_f_textField('n_dt_e_y',4,4,$dt_e_y,13).' '.
		 __('Time:').' '.
		php_f_textField('n_dt_e_h',2,2,$dt_e_h,13).':'.
		php_f_textField('n_dt_e_i',2,2,$dt_e_i,13).':'.
		php_f_textField('n_dt_e_s',2,2,$dt_e_s,13).' '. "</span></p>\n\n";
  }
  ?>

  <p><input name="preview" type="submit" class="submit" tabindex="14" value="<?php  echo __('Visualize [v]'); ?>"
  accesskey="v" />&nbsp;
  <input name="publish" type="submit" class="submit" tabindex="15" value="<?php  echo __('Save [s]'); ?>"
  accesskey="s" />
  <?php
  if (!empty($px_news_id) && $px_news_content_format == 'wiki')
  {
  	echo '&nbsp;<input name="transform" tabindex="16" type="submit" class="submit" '.
	'value="'. __('Transform in XHTML').'" />';
  }

  if (!empty($px_news_id))
  {
	echo '&nbsp;<input name="delete" type="submit" tabindex="17" class="submit" '.
	'value="'.  __('Delete').'" onclick="return '.
	'window.confirm(\''.addslashes( __('Are you sure you want to delete this news?')).'\')" />';
	echo php_f_hidden('resource_id',$px_news_id);
  }
  ?></p>
  </form>
  <h3><a onclick="openClose('wikihelp',0); return false" href="#"><img alt="<?php  echo __('show/hide'); ?>" id="img_wikihelp" src="themes/<?php echo $_px_theme; ?>/images/plus.png" /></a>
  <?php  echo __('Wiki syntax'); ?></h3>
  <div id="wikihelp" style="display: none;">
  <?php echo $m->getHelp('wiki-inline'); ?>
  </div>
  <script type="text/javascript"><!--
  openClose('wikihelp',-1);
  //--></script>
  
<?php endif; // end of if ($is_editable) 
endif; // end of add/edit/view a news
/*=================================================
 list news
=================================================*/
if (!empty($_REQUEST['op']) && 'list' == $_REQUEST['op']): // list news

echo '<form action="news.php" method="GET"><p>';
echo '<label for="m" style="display:inline;"><strong>'. __('Month:').' </strong></label>';
echo php_f_comboBox('m',$arry_months, $px_m);
echo ' <label for="cat_id" style="display:inline;"><strong>'. __('Category:').' </strong></label>';
echo php_f_comboBox('cat_id',$arry_cat,$cat_id);
echo ' <input type="hidden" name="op" id="op" value="list" /><input class="submit" type="submit" value="'. __('ok').'" />';
echo '</p></form>';

if ($res->isEmpty()) {
    echo '<p>'. __('No news.').'</p>'."\n\n";
} else {
	echo '<script type="text/javascript">'."\n".
		"<!--\n".
		"var js_post_ids = new Array('".implode("','",$res->getIDs('content'))."');\n".
		"//-->\n".
		"</script>\n";
	
	echo '<p class="small"><a href="#" onclick="mOpenClose(js_post_ids,1); return false;">'. __('Show all').'</a>'.
	' - <a href="#" onclick="mOpenClose(js_post_ids,-1); return false;">'. __('Hide all').'</a></p>';

   
    while (!$res->EOF()) {
        // edition links - yes dotclear is a really good reference :o)
        if ($m->user->user['user_id'] == $res->f('user_id') || authAsLevel(PX_AUTH_ADMIN, $_SESSION['website_id'])) {
            $editlinks = '[<strong><a href="'.$res->f('type_id').'.php?resource_id='.$res->f('resource_id').'">'. __('edit').'</a></strong>]';
        } else {
            $editlinks = '[<strong><a href="'.$res->f('type_id').'.php?resource_id='.$res->f('resource_id').'">'. __('visualize').'</a></strong>]';      
        }
        
        $res_class = '';
        $res_img = '';
        
		if ($res->f('status') == PX_RESOURCE_STATUS_OFFLINE) {
			$res_class = 'cancel';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_off.png" alt="'. __('Resource off-line').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_VALIDE) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_on.png" alt="'. __('Resource on-line').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_INEDITION) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_edit.png" alt="'. __('Resource in edition').'" class="status" />';
		} elseif ($res->f('status') == PX_RESOURCE_STATUS_TOBEVALIDATED) {
			$res_class = 'published';
			$res_img = '<img src="themes/'.$_px_theme.'/images/check_wait.png" alt="'. __('Resource waiting for validation').'" class="status" />';
		}     
        
        echo '<div class="line '.$res_class.'" id="p'.$res->f('resource_id').'">'.
			'<p><a href="#" onclick="openClose(\'content'.$res->f('resource_id').'\',0); return false;">'.
			'<img src="themes/'.$_px_theme.'/images/plus.png" id="img_content'.$res->f('resource_id').'" '.
			'alt="'. __('show/hide').'" /></a> ';

        $authors = $res->getAuthors();    
        echo $res->f('title').' - '. __('by');
  
        $temp = '';
        while (!$authors->EOF()) {
            $temp .= ' <strong>'.$authors->f('user_realname').'</strong>';
            $authors->moveNext();
        }
        echo $temp;
        echo ' - '. __('in');
        $cat = $res->getCategories();
        $temp = '';
        while (!$cat->EOF()) {
            $temp .= ' <em>'.$cat->f('category_name').'</em>,';
            $cat->moveNext();
        }
        $temp = substr($temp, 0, -1); 
        echo $temp."<br />\n";
        echo $res_img.'<strong>'.date( __('Y/m/d \a\t H:i:s'),makeTime($res->f('modifdate'))).'</strong> '.$editlinks;
        
        echo "</p>\n\n";
        echo '<div id="content'.$res->f('resource_id').'" style="display:none;">';
        echo textParseContent($res->f('description'))."\n";
        echo "\n<p><span class='small'>". __('Id to make a link:').' '.$res->f('identifier')."</span></p>\n<hr class='invisible' /></div></div>\n\n";    

        
        $res->moveNext();
    }
}

/*=================================================
 Form to search in the resources
=================================================*/
echo '<form action="news.php" method="GET"><p>';
echo '<label for="q" style="display:inline;"><strong>'. __('Search:').' </strong></label>';
echo php_f_textField('q', 30, 255, $px_q); 
echo ' <input class="submit" type="submit" value="'. __('ok').'" /><input type="hidden" name="op" value="list" />';
echo '</p></form>'."\n\n";

endif; // end of list news

/*=================================================
 Load common bottom page
=================================================*/
include $_PX_config['manager_path'].'/mtemplates/_bottom.php';

?>
