<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_NORMAL, (!empty($_SESSION['website_id']))?$_SESSION['website_id']:'');

/*=================================================
 Create the manager object, load the libs and class
=================================================*/
$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

/*==============================================================================
 Process block
==============================================================================*/
// get the values for the form from the session
$px_password = '';
$px_realname = $m->user->user['user_realname'];
$px_email    = $m->user->user['user_email'];
$px_pubemail = $m->user->user['user_pubemail'];
//$px_default  = (strlen($m->user->getPref('default_website')) > 0) ? $m->user->getPref('default_website') : $m->user->website;
$px_lang     = $m->user->getPref('lang');

// get the available languages
$localedir = dirname(__FILE__).'/locale/';
$arry_lang = array();
$arry_codes = $m->l10n->getIsoCodes();
$west_codes = $m->l10n->getIsoWestern();
$D = dir($localedir);
while(false !== ($entry = $D->read())) {
	if (is_dir($localedir.$entry) && preg_match('/^[a-z]{2}$/', $entry)) {
		if ('utf-8' == strtolower($_PX_config['encoding']) or in_array($entry, $west_codes)) {
			$label = $arry_codes[$entry];
			$arry_lang[$label] = $entry;
		}
	}
}
unset($arry_codes, $west_codes); //big arrays not needed anymore
$D->close();
$arry_lang['English'] = 'en';


// get the available themes
require dirname(__FILE__).'/extinc/class.plugins.php';
$themes_root = dirname(__FILE__).'/themes/';

$objPlugins = new plugins($themes_root);
$themes_list = $objPlugins->getPlugins('theme');


/*=================================================
 Save/Add the user
=================================================*/
if (!empty($_POST['save'])) {
    // Save the prefs
	$px_id       = $m->user->user['user_id'];
	$px_username = $m->user->user['user_username'];
	$px_password = trim($_POST['u_password']);
	$px_realname = trim($_POST['u_realname']);
	$px_email    = trim($_POST['u_email']);
	$px_pubemail = trim($_POST['u_pubemail']);
	//if (count($m->user->webs) > 1) {
	//	$px_default = trim($_POST['u_default']);
	//	$ok = $m->user->savePref('default_website', $px_default, '#all#');
	//	if ($ok !== true) {
	//		$m->setError($ok, 500);
	//	}
	//}
	$ok = $m->user->savePref('lang', trim($_POST['u_lang']), '#all#');
	if ($ok !== true) {
		$m->setError($ok, 500);
	}
	if (($ok === true) && false !== ($id = $m->saveUser($px_id, $px_username, $px_password, $px_realname, $px_email, $px_pubemail))) {
			$msg =  __('Preferences successfully saved.');
			header('Location: prefs.php?msg='.urlencode($msg));
			exit;
	}
}

if (!empty($_GET['switchtheme'])) {
	if (!empty($themes_list[trim($_GET['switchtheme'])])) {
		//theme exists, can be used
		$ok = $m->user->savePref('theme', trim($_GET['switchtheme']), '#all#');
		if ($ok !== true) {
			$m->setError($ok, 500);
		} else {
			$msg =  __('Theme successfully changed.');
			header('Location: prefs.php?msg='.urlencode($msg));
			exit;
		}
	}

}


/*==============================================================================
 Display block
==============================================================================*/
/*=================================================
 Set title of the page, and load common top page
=================================================*/
$px_title =  __('Preferences');
include $_PX_config['manager_path'].'/mtemplates/_top.php';

echo '<h1>'. __('Preferences')."</h1>\n\n";

?>

<form action="prefs.php" method="post" id="formPost">
  <p class="field"><label class="float" for="u_realname" style="display:inline"><strong><?php  echo __('Name:'); ?></strong></label>
  <?php echo php_f_textField('u_realname', 30, 50, $px_realname, '', ''); ?>
  </p>

  <p class="field"><label class="float" for="u_email" style="display:inline"><strong><?php  echo __('Email <span class="small">(not shown)</span>:'); ?></strong></label>
  <?php echo php_f_textField('u_email', 30, 50, $px_email, '', ''); ?>
  </p>

  <p class="field"><label class="float" for="u_pubemail" style="display:inline"><?php  echo __('Public email:'); ?></label>
  <?php echo php_f_textField('u_pubemail', 30, 50, $px_pubemail, '', ''); ?>
  </p>

  <p class="field"><label class="float" for="u_password" style="display:inline"><?php  echo __('Password:'); ?></label>
  <?php echo php_f_textField('u_password', 30, 50, '', '', ''); ?>
  <br /><?php  echo __('(keep empty not to change it)'); ?></p>

  <p class="field"><label class="float" for="u_lang" style="display:inline"><?php  echo __('Interface language:'); ?></label>
    <?php  echo php_f_combobox('u_lang', $arry_lang, $px_lang); ?></p>

<?php if (false && count($m->user->webs)): ?>
  <p class="field"><label class="float" for="u_default" style="display:inline"><?php  echo __('Default website to edit:'); ?></label>
<?php
reset($m->user->webs);
$arry_websites = array();
foreach ($m->user->webs as $site => $score) {
	$arry_websites[$m->user->wdata[$site]['website_name']] = $site;
}
echo php_f_combobox('u_default', $arry_websites, $px_default);
?><br />
  <span class="small"><?php  echo __('If saved in a cookie, the last edited website is proposed after login.'); ?></span>
  </p>
<?php endif; ?>

  <p> <input name="save" type="submit" class="submit" value="<?php  echo __('Save [s]'); ?>"
  accesskey="s" />
  </p>
</form>
<?php
if (count($themes_list) > 1):
?>
<hr class="soft" />
<h2><?php  echo __('Manager Themes'); ?></h2>

<dl class="themes-list">
<?php
	reset($themes_list);
	foreach($themes_list as $theme) {
		echo '<dt><img alt="" src="themes/'.$theme['name'].'/preview.png"> <strong>'.$theme['label'].'</strong> '.__('by').' '.$theme['author'].'</dt>'."\n";
		echo '<dd>'.$theme['desc'].' - '.__('version:').' '.$theme['version'];
		if ($_px_theme != $theme['name']) {
			echo '<br /><a href="prefs.php?switchtheme='.$theme['name'].'"><strong>'.__('Use this theme').'</strong></a>';
		}
		echo '</dd>'."\n\n";
	}
	echo '</dl>'."\n";
endif;

/*=================================================
 Load common bottom page
=================================================*/
include $_PX_config['manager_path'].'/mtemplates/_bottom.php';

?>
