<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is DotClear Weblog.
#
# The Initial Developer of the Original Code is
# Olivier Meunier.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
?>

<?php
include_once dirname(__FILE__).'/../../inc/class.l10n.php';
include_once dirname(__FILE__).'/../../inc/class.files.php';
include_once dirname(__FILE__).'/../../inc/class.checklist.php';

$m->l10n->loadPlugin($u->lang, 'babel');
$is_user_root = authAsLevel(PX_AUTH_ROOT, $_SESSION['website_id']);
if (!$is_user_root):
    $m->setError( __('You do not have the rights to access this plugin.'));
else:


?>
<h1><?php  echo __('Babel Fish'); ?></h1>

<h2><?php  echo __('Optimization of the locale files'); ?></h2>
<?php
if (!empty($_GET['op']) && ($_GET['op'] == 'op')) {
	echo '<p><strong>'.__('Results of the optimization:').'</strong></p>'."\n\n";
	$checklist = new checklist();
	$files = array();
	files::listfiles($_PX_config['manager_path'].'/locale', $files, '/\.lang$/');
	files::listfiles($_PX_config['manager_path'].'/tools', $files, '/\.lang$/');
	$i = 1;
	foreach($files as $file) {
		$checklist->addTest('file'.$i, l10n::optimizeLocale($file),
			sprintf(__('Locale file <strong>%s</strong> optimized.'), $file),
			sprintf(__('Error optimizing the file <strong>%s</strong>.'), $file));
			$i++;
	}
	echo $checklist->getHtml('themes/'.$_px_theme.'/images');
	if ($checklist->checkAll()) {
		echo '<p>'.__('The optimization was successfull. You will have a little increase in the speed of the manager. You need to run again the optimization after adding a new plugin or upgrading your installation.').'</p>'."\n";
	} else {
		echo '<p>'.__('The optimization was not successfull. Do not worry too much, this would have not increased a lot the speed of the manager.').'</p>'."\n";
	}
} else {
	echo '<p>'.__('The optimization convert the <strong>.lang</strong> files in <strong>PHP</strong> files ready for inclusion, thus improving the speed of the manager. There is an automatic check to use the <strong>.lang</strong> file if more recent.').'</p>'."\n";
	echo '<p>'.sprintf(__('<a href="%s">Run the optimization</a>.'), 'tools.php?p=babel&amp;op=op').'</p>'."\n";
}


endif; // if user root
?>
