<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is DotClear Weblog.
#
# The Initial Developer of the Original Code is
# Olivier Meunier.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****
?>

<?php
include_once dirname(__FILE__).'/../../extinc/lib.image.php';
include_once dirname(__FILE__).'/lib.dir.php';

$m->l10n->loadPlugin($u->lang, 'info');
$is_user_root = authAsLevel(PX_AUTH_ROOT, $_SESSION['website_id']);
if (!$is_user_root):
    $m->setError( __('You do not have the rights to access this plugin.'));
else:    

if (!empty($_GET['cleancache']) && !empty($_GET['id'])) {
    // try to clean the cache
    $siteid = $_GET['id'];
    if (!empty($m->user->wdata[$siteid]['website_name'])) {
        // ok the site exists
        recursiveDelete($_PX_config['manager_path'].'/cache/'.$siteid.'/');
        clearstatcache();
        @mkdir($_PX_config['manager_path'].'/cache/'.$siteid.'/', 0777);
        @touch($_PX_config['manager_path'].'/cache/'.$siteid.'/MASS_UPDATE', time());
        $msg =  __('The cache of the website has been reset.');
		header('Location: tools.php?p=info&msg='.urlencode($msg));
		exit; 
    } else {
        $m->setError( __('Error&nbsp;: Website not available.'), 400);
    }                
}

?>
<h1><?php  echo __('Information'); ?></h1>

<h2><?php  echo __('General information'); ?></h2>
<?php


// Version 
if (file_exists(dirname(__FILE__).'/../../VERSION')) {
	$px_version = trim(implode('',file(dirname(__FILE__).'/../../VERSION')));
	
	echo '<p>'.sprintf( __('You are using PLUME CMS version <strong>%s</strong>.'), $px_version).'</p>';
}

$con =& pxDBConnect();
$rs = $con->select('SHOW TABLE STATUS FROM '.$_PX_config['db']['db_database']);

echo '<p>'. __('The PLUME CMS tables in your database are:').'</p>';
echo '<table class="clean-table">';
echo '<tr><th>'. __('Name').'</th><th>'. __('Records').'</th><th>'. __('Size').'</th></tr>';
while (!$rs->EOF())
{
	if (preg_match('#'.$con->pfx.'#',$rs->f('name'))) {
		echo '<tr>';
		echo '<td>'.$rs->f('name').'</td>';
		echo '<td>'.$rs->f('rows').'</td>';
		echo '<td>'.prettySize($rs->f('Data_length')+$rs->f('Index_length')).'</td>';
		echo '</tr>';
	}
	
	$rs->moveNext();
}
echo '</table>';
?>

<h3><?php  echo __('Cache information'); ?></h3>

<?php
echo '<table class="clean-table">';
echo '<tr><th>'. __('Website').'</th><th>'. __('Cache size').'</th><th>'. __('Reset the cache').'</th></tr>';
reset($m->user->webs);
foreach ($m->user->webs as $site => $score) {
    $size = dirSize($_PX_config['manager_path'].'/cache/'.$site.'/');
    if ($size) {
        $link = sprintf('<a href="tools.php?p=info&amp;cleancache=1&amp;id='.$site.'">%s</a>', __('Reset'));
    } else {
        $link = '&nbsp;';
    }         
    echo '<tr>';
    echo '<td>'.$m->user->wdata[$site]['website_name'].'</td>';
    echo '<td>'.prettySize($size).'</td>';
    echo '<td>'.$link.'</td>';
    echo '</tr>';
}
echo '</table>';

?>

<p><?php  echo __('If you are making modifications to your templates, you should clean the cache before testing them.'); ?></p>

<h3><?php  echo __('File information'); ?></h3>

<?php $img_check = '<img src="themes/'.$_px_theme.'/images/check_%s.png" alt="" />'; ?>

<?php

if (is_writable($_PX_config['manager_path'].'/cache')) {
	echo '<p>'.sprintf($img_check,'on').' '.sprintf( __('The system has write access on the folder %s.'),cleanDirname($_PX_config['manager_path'].'/cache')).'</p>';
} else {
	echo '<p>'.sprintf($img_check,'off').' '.sprintf( __('The system has no write access on the folder %s.'),cleanDirname($_PX_config['manager_path'].'/cache')).'</p>';
}

if (is_writable($_PX_config['manager_path'].'/conf')) {
	echo '<p>'.sprintf($img_check,'on').' '.sprintf( __('The system has write access on the folder %s.'),cleanDirname($_PX_config['manager_path'].'/conf')).'</p>';
} else {
	echo '<p>'.sprintf($img_check,'off').' '.sprintf( __('The system has no write access on the folder %s.'),cleanDirname($_PX_config['manager_path'].'/conf')).'</p>';
}

reset($m->user->webs);
foreach ($m->user->webs as $site => $score) {
    if (is_writable($_PX_config['manager_path'].'/conf/configweb_'.$site.'.php')) {
	    echo '<p>'.sprintf($img_check,'on').' '.sprintf( __('The system has write access on the file %s.'),cleanDirname($_PX_config['manager_path'].'/conf/configweb_'.$site.'.php')).'</p>';
    } else {
	    echo '<p>'.sprintf($img_check,'off').' '.sprintf( __('The system has no write access on the file %s.'),cleanDirname($_PX_config['manager_path'].'/conf/configweb_'.$site.'.php')).'</p>';
    }
    if (is_writable($m->user->wdata[$site]['website_xmedia_path'])) {
	    echo '<p>'.sprintf($img_check,'on').' '.sprintf( __('The system has write access on the folder %s.'),cleanDirname($m->user->wdata[$site]['website_xmedia_path'])).'</p>';
    } else {
	    echo '<p>'.sprintf($img_check,'off').' '.sprintf( __('The system has no write access on the folder %s.'),cleanDirname($m->user->wdata[$site]['website_xmedia_path'])).'</p>';
    }
    if (is_writable($m->user->wdata[$site]['website_xmedia_path'].'/thumb')) {
	    echo '<p>'.sprintf($img_check,'on').' '.sprintf( __('The system has write access on the folder %s.'),cleanDirname($m->user->wdata[$site]['website_xmedia_path'].'/thumb')).'</p>';
    } else {
	    echo '<p>'.sprintf($img_check,'off').' '.sprintf( __('The system has no write access on the folder %s.'),cleanDirname($m->user->wdata[$site]['website_xmedia_path'].'/thumb')).'</p>';
    }
}

?>


<h3><?php  echo __('Server information'); ?></h3>

<p><?php echo sprintf( __('Your PHP version is <strong>%s</strong>.'),phpversion()); ?></p>

<?php
if (($rs = $con->select('SELECT VERSION() AS version')) !== false) {
	$mysql_version = preg_replace('/-log$/','',$rs->f(0));
	echo '<p>'.sprintf( __('Your MySQL version is <strong>%s</strong>.'),$mysql_version).'</p>';
	
}

if (!empty($_SERVER['SERVER_SOFTWARE'])) {
	echo '<p>'.sprintf( __('Your webserver is <strong>%s</strong>.'),$_SERVER['SERVER_SOFTWARE']).'</p>';
}

$gd_version = gd_version(); 

if ($gd_version) {
	echo '<p>'.sprintf( __('Your GD graphic library version is <strong>%s</strong>.'),$gd_version).'</p>';
}

endif;
?>
