<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

$m->l10n->loadPlugin($u->lang, 'searchmng');
$con =& pxDBConnect();
$env  = (!empty($_GET['env'])) ? $_GET['env'] : 1;

/*==============================================================================
 Functions needed for the lists
==============================================================================*/
require_once $_PX_config['manager_path'].'/extinc/class.lum.php';
require_once $_PX_config['manager_path'].'/inc/class.search.php';

function line_res($data, $i)
{
	global $_px_ptheme,$env;
	$reindex = sprintf('<a href="tools.php?p=searchmng&amp;op=index&amp;env='.$env.'&amp;id=%s" title="'.__('Index the resource').'"><img src="tools/searchmng/themes/'.$_px_ptheme.'/index.png" alt=" "/></a>',
		urlencode($data['identifier']));
	if (strlen($data['title']) > 50) {
		$data['title'] = '<span title="'.$data['title'].'">'.substr($data['title'],0,47).'...</span>';
	}
	$strings['ok'] = __('Up to date');
	$strings['old'] = __('Index too old');
	$strings['not'] = __('Not indexed');

	$status = '<img src="tools/searchmng/themes/'.$_px_ptheme.'/icon_%s.png" alt="%s"/>';
	$data['status'] = sprintf($status, $data['status'], $strings[$data['status']]);
	return '<tr><td>'.$data['status'].'</td><td>'.$data['title'].'</td><td>'.$data['date'].'</td><td>'.$data['total'].'</td><td>'.$reindex.'</td></tr>'."\n";
}


/*==============================================================================
 Process block
==============================================================================*/
$s = new Search($con, $m->user->website);

//-- Index a resource if asked --//
if (!empty($_GET['op']) && 'index' == $_GET['op'] && !empty($_GET['id'])) {
	list($type, $id) = split('-', $_GET['id']);
	if ('art' == $type) $type = 'Article';
	else $type = 'News';
	$id = trim($id);
	if (false !== ($res = $m->getResourceByIdentifier($id, $type))) {
		if ($id == $res->f('resource_id')) {
			if (false !== $m->indexResource($id, $res)) {
				$msg =  __('The resource has been successfully indexed.');
				header('Location: tools.php?p=searchmng&env='.$env.'&msg='.urlencode($msg));
				exit;
			}
		}
	}
}

//-- Clean the index if asked --//
if (!empty($_GET['op']) && 'clean' == $_GET['op']) {
	if (false !== ($words = $s->clean_index())) {
		$msg =  sprintf(__('The index has been cleaned with <strong>%s</strong> unused word(s) removed.'), $words);
		header('Location: tools.php?p=searchmng&msg='.urlencode($msg));
		exit;
	}
}




$rs = $s->get_indexed_resources_stats($m->user->website);
$i = 0;
while (($rs !== false) && !$rs->EOF()) {
	$indextime = makeTime($rs->f('lastindex'));
	$modiftime = makeTime($rs->f('modificationdate'));
	if (0 == $indextime) {
		$rs_list[$i]['status'] = 'not';
	} elseif ($indextime < $modiftime) {
		$rs_list[$i]['status'] = 'old';
	} else {
		$rs_list[$i]['status'] = 'ok';
	}
	$rs_list[$i]['date'] = date( __('Y/m/d&\nb\sp;H:i:s'), $indextime);
	$rs_list[$i]['title'] = $rs->f('title');
	$rs_list[$i]['identifier'] = $rs->f('identifier');
	$rs_list[$i]['total'] = $rs->f('nbindex');
	$i++;
	$rs->moveNext();
}

/*==============================================================================
 Display block
==============================================================================*/
?>
<h1><?php  echo __('Search Manager'); ?></h1>

<h2><?php  echo __('Indexed resources'); ?></h2>
<?php

$objLum = new lum($env, 'line_res', $rs_list, 0, 20);
$objLum->htmlHeader = '<table class="clean-table">'."\n".'<tr><th>'.__('Status').'</th><th>'.__('Resource title').'</th><th>'.__('Last indexation').'</th><th colspan="2">'.__('Number').'</th></tr>'."\n";

$objLum->htmlLineStart = '';
$objLum->htmlColStart = '';
$objLum->htmlColEnd = '';
$objLum->htmlLineEnd = '';
$objLum->htmlFooter = '</table>'."\n";

$objLum->htmlLinksStart = '<p class="small">';
$objLum->htmlLinksEnd = '</p>';

$objLum->htmlCurPgStart = '<strong>';
$objLum->htmlCurPgEnd = '</strong>';

$objLum->htmlPrev =  __('&laquo; previous page');
$objLum->htmlNext =  __('&raquo; next page');
$objLum->htmlPrevGrp = '...';
$objLum->htmlNextGrp = '...';

$objLum->htmlEmpty = '<p><strong>'. __('No resources.').'</strong></p>';
$objLum->htmlLinksLib =  __('page(s):');

echo $objLum->drawLinks();
echo $objLum->drawPage();
echo $objLum->drawLinks();
$status = '<img src="tools/searchmng/themes/'.$_px_ptheme.'/icon_%s.png" alt="%s"/>';
?>
<ul class="checklist">
<li><?php echo sprintf($status,'ok',__('Up to date')).' '.__('Up to date'); ?></li>
<li><?php echo sprintf($status,'old',__('Index too old')).' '.__('Index too old'); ?></li>
<li><?php echo sprintf($status,'not',__('Not indexed')).' '.__('Not indexed'); ?></li>
</ul>

<h2><?php  echo __('Index maintenance'); ?></h2>
<?php $url = 'tools.php?p=searchmng&amp;op=clean'; ?>
<p><?php echo sprintf(__('<a href="%s">Clean the index of unused words</a>. This operation may take a long time and is database intensive.'), $url); ?></p>
