<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_ADMIN, (!empty($_SESSION['website_id']))?$_SESSION['website_id']:'');

/*=================================================
 Create the manager object, load the libs and class
=================================================*/
$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

/*=================================================
 Get some info of the current step for the submenu
=================================================*/
if (empty($_REQUEST['op']) && empty($_REQUEST['user_id'])) $display_add_user = true;
else $display_add_user = false;
$px_submenu->addItem( __('New author'),  'users.php?op=add',  'themes/'.$_px_theme.'/images/ico_new.png', false, $display_add_user);
$px_submenu->addItem( __('Back to the list of authors'),  'users.php',  'themes/'.$_px_theme.'/images/ico_back.png', false, !$display_add_user);

/*==============================================================================
 Process block
==============================================================================*/

if (empty($_REQUEST['op']) && empty($_REQUEST['user_id'])) { 
    // list the users
    $px_users = $m->getUsers();
} else {
    // edit a user
    // set default values
    $px_is_admin = false; // Has the user the admin level somewhere?
    $px_edit_ok  = false;
    $px_id       = '';
    $px_username = '';   	  
    $px_password = '';  	  
    $px_realname = '';  	  
    $px_email    = '';  
    $px_pubemail = '';  	  
    $px_levels   = array();   
    $arry_levels[ __('Administrator')]    = PX_AUTH_ADMIN;
    $arry_levels[ __('Advanced author')] = PX_AUTH_ADVANCED;
    $arry_levels[ __('Simple author')]   = PX_AUTH_NORMAL;
    $arry_levels[ __('No access')]  = PX_AUTH_DISABLE;
	$px_res = new Recordset();

    if (!empty($_REQUEST['user_id'])) {
        $px_user = $m->getUserById($_REQUEST['user_id']);
        $px_id       = $px_user->f('user_id');
        $px_username = $px_user->f('user_username');   	  
        $px_realname = $px_user->f('user_realname');  	  
        $px_email    = $px_user->f('user_email');  
        $px_pubemail = $px_user->f('user_pubemail');  	  
        $px_levels   = $px_user->getWebsites($px_id); 
		$px_res      = $px_user->getListResources(); // to get all the resources
		                                             // even in another website 
        foreach ($px_user->webs as $site => $score) {
            if ($score >= PX_AUTH_ADMIN) {
                $px_is_admin = true;
                break;
            }
        } 
        reset($px_user->webs);     
        if (authAsLevel(PX_AUTH_ROOT, $_SESSION['website_id']) || !$px_is_admin || $px_id == $m->user->_userid) {                                                        
            $px_edit_ok = true;
        }                                                                  
    } else {
        // new user
        $px_edit_ok = true;
    }        
        
}

/*=================================================
 Save/Add the user
=================================================*/
if (!empty($_POST['save'])) {
    // Populate the list of websites
    $authwebs = array();
    // populate the $authwebs with the data from database
    // so no site can be removed
    if ($px_id) {
        foreach ($px_user->webs as $site => $score) {
            $authwebs[$site] = $score;
        }
    }
    foreach ($m->user->webs as $site => $score) {
		if ($score >= PX_AUTH_ADMIN) {
    		if (isset($_POST['u_website_'.$site]) && $_POST['u_website_'.$site] != PX_AUTH_DISABLE) {
    			$authwebs[$site] = $_POST['u_website_'.$site];
				$px_levels[$site] = $_POST['u_website_'.$site];
    		} elseif (isset($_POST['u_website_'.$site]) && $_POST['u_website_'.$site] == PX_AUTH_DISABLE) {
    			unset($authwebs[$site]);  //= $_POST['u_website_'.$site];
				unset($px_levels[$site]); // = $_POST['u_website_'.$site];            
            }
		}    
	}

    // now need to be sure that when the user is admin the level is not changed
    // except the case of the user doing the operation to be root
    if ($px_id) {
        if (!authAsLevel(PX_AUTH_ROOT, $_SESSION['website_id'])) {
            reset($px_user->webs);
            foreach ($px_user->webs as $site => $score) {
                if ($score >= PX_AUTH_ADMIN) {
                    $authwebs[$site] = $score;
                }
            }     
        }
    }
    
    if ($px_edit_ok) {
    	$px_username = trim($_POST['u_username']); 
    	$px_password = trim($_POST['u_password']);
    	$px_realname = trim($_POST['u_realname']);
    	$px_email    = trim($_POST['u_email']);
    	$px_pubemail = trim($_POST['u_pubemail']);
    }
		
	if (false !== ($id = $m->saveUser($px_id, $px_username, $px_password, $px_realname, $px_email, $px_pubemail, $authwebs))) {
		if ($id == $m->user->_userid) {
			header('Location: login.php?logout=1');
			exit; 
		}
		$msg =  __('The author has been successfully saved.');
		header('Location: users.php?msg='.urlencode($msg));
		exit; 
	}	
} 
/*=================================================
 Remove a user
=================================================*/
if (!empty($_POST['delete']) && !empty($px_id)) {
	if ($px_id == 1) {
		$m->setError( __('Error: This user cannot be deleted.'), 400);
	} else {
		if ($px_res->nbRow() != 0) {
			$m->setError( __('Error: This user cannot be deleted.'), 400);
		} else {
			if (false !== $m->delUser($px_id)) {
				$msg =  __('Author successfully deleted.');
				header('Location: users.php?msg='.urlencode($msg));
				exit; 
			}
		}
	}
}

/*==============================================================================
 Display block
==============================================================================*/
/*=================================================
 Set title of the page, and load common top page
=================================================*/
$px_title =  __('Authors');
include $_PX_config['manager_path'].'/mtemplates/_top.php';

echo '<h1>'. __('Authors')."</h1>\n\n";

if (empty($_REQUEST['op']) && empty($_REQUEST['user_id'])) { 
    // list the users
    while(!$px_users->EOF()) {
        $res = $px_users->getListResources($m->user->website);
        
        echo '<div class="line" id="p'.$px_users->f('user_id').'"><p>';
        if (($px_users->f('user_id') != 1) || authAsLevel(PX_AUTH_ROOT, $_SESSION['website_id'])) {
            echo '<a href="users.php?user_id='.$px_users->f('user_id').'"><strong>'.$px_users->f('user_realname').'</strong></a>';
        } else {
            echo '<strong>'.$px_users->f('user_realname').'</strong>';
        }
        echo ' ['.$res->nbRow().' '. __('resource(s)').']';
        echo "</p>\n\n";
        echo "\n</div>\n\n";    
        		

		$px_users->moveNext();			
	} 
} else {
    if ($m->user->_userid == $px_id) {
        echo '<p class="message">'. __('Attention, you are modifying your profile. You will be logged out if changes are successfully made.').'</p>'."\n\n";
    }

?>


<form action="users.php" method="post" id="formPost">
  <p class="field"><label class="float" for="u_username" style="display:inline"><strong><?php  echo __('Login:'); ?></strong></label>
  <?php if ($px_edit_ok) { 
            echo php_f_textField('u_username', 30, 30, $px_username, '', ''); 
        } else {
            echo $px_username;
        }      
  ?>
  </p>
  
  <p class="field"><label class="float" for="u_realname" style="display:inline"><strong><?php  echo __('Name:'); ?></strong></label>
  <?php if ($px_edit_ok) { 
            echo php_f_textField('u_realname', 30, 50, $px_realname, '', ''); 
        } else {
            echo $px_realname;
        }      
  ?>
  </p>

  <p class="field"><label class="float" for="u_email" style="display:inline"><strong><?php  echo __('Email <span class="small">(not shown)</span>:'); ?></strong></label>
  <?php if ($px_edit_ok) { 
            echo php_f_textField('u_email', 30, 50, $px_email, '', ''); 
        } else {
            echo $px_email;
        }      
  ?>
  </p>  

  <p class="field"><label class="float" for="u_pubemail" style="display:inline"><?php  echo __('Public email:'); ?></label>
  <?php if ($px_edit_ok) { 
            echo php_f_textField('u_pubemail', 30, 50, $px_pubemail, '', ''); 
        } else {
            echo $px_pubemail;
        }      
  ?>
  </p>  

<?php if ($px_edit_ok): ?>
  <p class="field"><label class="float" for="u_password" style="display:inline"><?php  echo __('Password:'); ?></label>
  <?php echo php_f_textField('u_password', 30, 50, '', '', ''); ?>
  <br /><?php  echo __('(keep empty not to change it)'); ?></p>    
<?php endif; ?>
  
  <p><strong><?php  echo __('Levels'); ?></strong></p>
  
  <?php 
  foreach ($m->user->webs as $site => $score) {
    if ($score >= PX_AUTH_ADMIN) {
        echo '<p class="field"><label for="u_website_'.$site.'" style="display:inline">';
        echo sprintf( __('Site <strong>%s</strong>:'), $m->user->wdata[$site]['website_name']);
        echo '</label> ';
        if (!isset($px_levels[$site])) $px_levels[$site] = PX_AUTH_DISABLE;
        if ($px_levels[$site] >= PX_AUTH_ADMIN && !$px_edit_ok) {
            echo  __('Administrator');
        } else {
            echo php_f_combobox('u_website_'.$site, $arry_levels, $px_levels[$site]);
        }
    }    
  }
  if (!empty($px_id)) {
   	 echo php_f_hidden('user_id',$px_id);
  } else { 
	 echo php_f_hidden('op','add');
  }
  ?>
  <p> <input name="save" type="submit" class="submit" value="<?php  echo __('Save [s]'); ?>"
  accesskey="s" />&nbsp;  
  <?php
    if ($px_res->nbRow() == 0 && !empty($px_id)) {
	echo '&nbsp;<input name="delete" type="submit" class="submit" '.
	'value="'.  __('Delete').'" onclick="return '.
	'window.confirm(\''.addslashes( __('Are you sure you want to delete this author?')).'\')" />';
   
  }
  ?>
  </p>
</form>
<?php
}

/*=================================================
 Load common bottom page
=================================================*/
include $_PX_config['manager_path'].'/mtemplates/_bottom.php';

?>
