<?php
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1\
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is PLUME CMS.
#
# The Initial Developer of the Original Code is
# loic d'Anterroches.
# Portions created by the Initial Developer are Copyright (C) 2003
# the Initial Developer. All Rights Reserved.
#
# Credits:
#   Olivier Meunier. The administration part of PLUME CMS starting 
#   version 1.0RC1 is mainly based on DotClear Weblog by Olivier Meunier. 
#   More details: http://www.dotclear.net/
#   DotClear Weblog is distributed under the License MPL 1.1/GPL 2.0/LGPL 2.1
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****

require_once 'path.php';
require_once $_PX_config['manager_path'].'/prepend.php';
auth(PX_AUTH_NORMAL, (isset($_SESSION['website_id']))?$_SESSION['website_id']:'');

/*=================================================
 Create the manager object, load the libs and class
=================================================*/
$u = new User();
$u->synchronize(PX_USER_SYNCHRO_FROM_SESSION);
$m = new Manager();
$m->setUser($u);
$_px_theme = $m->user->getTheme();

require_once $_PX_config['manager_path'].'/extinc/class.lum.php';
require_once $_PX_config['manager_path'].'/extinc/lib.image.php';

if (file_exists($_PX_config['manager_path'].'/conf/configweb_'.$_SESSION['website_id'].'.php')) {
	include($_PX_config['manager_path'].'/conf/configweb_'.$_SESSION['website_id'].'.php');
} else {
	$m->setError(sprintf( __('Error: Configuration file of the website(<strong>%s</strong>) not available.'),$_PX_config['manager_path'].'/conf/configweb_'.$_SESSION['website_id'].'.php'), 500);
}


/*
	for the moment the logic is here, completely based on the work done in
	dotclear with extension to almost all the kind of files, but will need
	to move it into classes at some point.
*/
$px_gd_version = gd_version();
$mode = (!empty($_REQUEST['mode'])) ? $_REQUEST['mode'] : '';
$env  = (!empty($_GET['env'])) ? $_GET['env'] : 1;
$is_writable = false;
$is_dir = true;

if (false === $m->error()):
$up_dir = $_PX_website_config['xmedia_root'];

//set the current dir and mode from the session if info available
if (empty($_REQUEST['dir'])) {
	$current_dir = $m->user->getPref('xmedia_current_dir');
	if (!empty($current_dir)) {
		//the current dir is coming from the session, set the $env from it or set it to 1
		$env  = ($m->user->getPref('xmedia_current_page')) ? $m->user->getPref('xmedia_current_page') : 1;
		//we need to ensure a "correct" request URI to work with the lum class
		if ('.php' == substr($_SERVER['REQUEST_URI'], strlen($_SERVER['REQUEST_URI'])-4, 4))
			$_SERVER['REQUEST_URI'] .= '?';
		$_SERVER['REQUEST_URI'] = str_replace('?','?dir='.$current_dir.'&env='.$env.'&',$_SERVER['REQUEST_URI']);
	}
} else {
	$current_dir = $_REQUEST['dir'];
}

if (!empty($current_dir)) {
	$current_dir = str_replace('\\','',$current_dir);
	$current_dir = str_replace('..','',$current_dir);
	$current_dir = preg_replace( '#(/)+#', '/', $current_dir);
	$current_dir = preg_replace( '#^(/)+#', '', $current_dir);
	$current_dir = preg_replace( '#(/)+$#', '', $current_dir);
	if (!empty($current_dir))
		$current_dir .= '/';
} else {
	$current_dir = '';
}

/* check rights */
if(is_dir($up_dir.'/'.$current_dir))
{
	if (is_writable($up_dir.'/'.$current_dir)) {
		$is_writable = true;
	} else {
		$m->setError(sprintf( __('Error: The system has no write access to the folder <strong>%s</strong>. Check the permissions.'),$_PX_website_config['rel_url_files'].'/'.$current_dir), 500);

	}
}
else
{
	$m->setError(sprintf( __('Error: The folder <strong>%s</strong> does not exist.'),$_PX_website_config['rel_url_files'].'/'.$current_dir), 500);
	$is_dir = false;
}
endif; //end of if (false === $m->error()):
if ($is_dir) {
	$m->user->savePref('xmedia_current_dir', $current_dir, $_SESSION['website_id'], true);
} else {
	$m->user->savePref('xmedia_current_dir', '/', $_SESSION['website_id'], true);
	$current_dir = '/';
}
/* modification of the file */
if (!empty($_GET['file']) && (false === $m->error()))
{
	$px_file = str_replace('..','',$_GET['file']);
	$px_file = preg_replace( '#(/)+#', '/', $px_file); 
	$px_file = preg_replace( '#^(/)+#', '', $px_file); 
	
	if (!file_exists($up_dir.'/'.$px_file))
	{
		$m->setError( __('Error: The requested file does not exist.'), 400);
	}
	else
	{
		if (!empty($_GET['del']) && $_GET['del'] == 1)
		{
			if (@unlink($up_dir.'/'.$px_file) === false)
			{
				$m->setError( __('Error: Impossible to delete the file.'), 500);
			}
			else
			{
				@unlink($up_dir.'/thumb/'.md5($px_file).'.jpg');
				
				$msg =  __('File deleted with success.');
				header('Location: xmedia.php?dir='.rawurlencode($current_dir).'&msg='.rawurlencode($msg).'&mode='.$mode);
				exit();
			}
		}
		elseif(!empty($_GET['thumb']) && $_GET['thumb'] == 1)
		{
			$thumb  = $up_dir.'/thumb/'.md5($px_file).'.jpg';
			@$thumb = cropImg($up_dir.'/'.$px_file, $thumb, 150, 100);
		}
	}
}

/* Upload of the file */
if ($is_writable && !empty($_FILES['up_file']) && (false === $m->error())) {
	$tmp_file = $_FILES['up_file']['tmp_name'];
	$file_name = $_FILES['up_file']['name'];

	if (version_compare(phpversion(),'4.2.0','>=')) {
		$upd_error = $_FILES['up_file']['error'];
	} else {
		$upd_error = 0;
	}

	if($upd_error != 0)
	{
		switch ($upd_error) {
		case 1:
		case 2:
			$m->setError( __('Error: The size of the file excess the maximum size.'), 400);
			break;
		case 3:
			$m->setError( __('Error: File not fully transfered.'), 400);
			break;
		case 4:
			$m->setError( __('Error: No file.'), 400);
			break;
		}
	}
	elseif(!file_exists($tmp_file))
	{
		$m->setError( __('Error: No file.'), 400);
	}
	elseif(filesize($tmp_file) > $_PX_config['max_upload_size'])
	{
		$m->setError( __('Error: The size of the file excess the maximum size.'), 400);
	}
	else
	{	
		if(!isFileSafe($file_name, $tmp_file))
		{
			$m->setError( __('Error: Not an authorized type of file. The file name must contain only simple letters, digits, "-", "_" and a recognized extension. No spaces allowed.'), 400);
		}
		else
		{
			if(@copy($tmp_file,$up_dir.'/'.$current_dir.$file_name))
			{
				@chmod($up_dir.'/'.$current_dir.$file_name, 0666);
				/* create thumb */
				$thumb = $up_dir.'/thumb/'.md5($current_dir.$file_name).'.jpg';
				@unlink($thumb); //ensure that the old thumbnail is removed if available
				@$msg=cropImg($up_dir.'/'.$current_dir.$file_name, $thumb, 150, 100);
				@chmod($thumb, 0666);
				
				$msg =  __('File successfully uploaded.');
				header('Location: xmedia.php?dir='.rawurlencode($current_dir).'&msg='.rawurlencode($msg).'&mode='.$mode.'&env='.$env);
				exit();
			}
			else
			{
				$m->setError( __('An error occured during the transfer of the file.'), 500);
			}
		}
	}
}

/* Create a subfolder */
if ($is_writable && !empty($_POST['create']) && (false === $m->error())
	&& (authAsLevel(PX_AUTH_ADVANCED, (isset($_SESSION['website_id']))?$_SESSION['website_id']:''))
	) {
	if (!empty($_POST['new_folder'])) {
		$new_dir = trim($_POST['new_folder']);
		if (preg_match('/[^A-Za-z0-9\-\_]/', $new_dir) or ($new_dir == 'thumb')) {
			$m->setError( __('Error: Invalid folder name, it must contain only letters, digits, "_" and "-".'), 400);
		} else {
			if (@mkdir($up_dir.'/'.$current_dir.$new_dir, 0777)) {
				$msg =  __('The folder was successfully created, you can already add files and images in.');
				header('Location: xmedia.php?dir='.rawurlencode($current_dir.$new_dir).'&msg='.rawurlencode($msg).'&mode='.$mode);
				exit();
			
			} else {
				$m->setError( __('Error: Impossible to create the new folder.'), 500);
			}
		
		}
	}		
}


/* Delete a subfolder */
if ($is_writable && !empty($_REQUEST['delfolder']) && (false === $m->error())
	&& (authAsLevel(PX_AUTH_ADVANCED, (isset($_SESSION['website_id']))?$_SESSION['website_id']:''))) {
	
	$can_delete = true;
	$can_delete = (strlen($current_dir) != 0) ? true : false;

	if ($is_dir && $can_delete) {
		$D = dir($up_dir.'/'.$current_dir);
		while(false !== ($entry = $D->read())) {
			if ($entry != '.' && $entry != '..' && $entry != '.htaccess' && $entry != '.htpasswd') {
				 $can_delete = false;
				 break;
			}
		}
		$D->close(); 
	}

	if ($can_delete) {
		// brut force delete of possible files

		if (file_exists($up_dir.'/'.$current_dir.'.htaccess'))
			@unlink($up_dir.'/'.$current_dir.'.htaccess');
		if (file_exists($up_dir.'/'.$current_dir.'.htpasswd'))
			@unlink($up_dir.'/'.$current_dir.'.htpasswd'); 

		if (!rmdir($up_dir.'/'.$current_dir)) {
			$m->setError( __('Error: Impossible to delete the folder.'), 500);
		} else {
			$msg = __('Folder successfully deleted.');
			$dir = getParentDir($current_dir);
			if (empty($dir)) $dir = '/';
			header('Location: xmedia.php?dir='.rawurlencode($dir).'&msg='.rawurlencode($msg).'&mode='.$mode);
			exit();
		}
	}
}

/*==============================================================================
 Display block
==============================================================================*/

/*=================================================
 Set title of the page, and load common top page
=================================================*/
$px_title =  __('Files and images');

if ($mode == 'popup') {
	include dirname(__FILE__).'/mtemplates/_pop_top.php';
} else {
	// sub menu
	$px_submenu->addItem( __('Back to the list of resources'),'index.php','themes/'.$_px_theme.'/images/ico_back.png',false);
	
	include dirname(__FILE__).'/mtemplates/_top.php';
}

echo '<h1>'. __('Files and images')."</h1>\n\n";

?>

<?php if($is_writable) : ?>

<form enctype="multipart/form-data" action="xmedia.php" method="post" onsubmit="return isReady('up_file','<?php echo __('Error: No file.') ?>')">
<fieldset><legend><?php   echo __('Add a file to the current folder'); ?></legend>
<p><label for="up_file"><?php  echo sprintf( __('Chose a file (maximum size %s)'), prettySize($_PX_config['max_upload_size'])); ?> <?php $m->HelpLink('xmedia', 'h-add-file'); ?></label>
<input name="up_file" id="up_file" type="file" />
<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo $_PX_config['max_upload_size']; ?>" />
<input type="hidden" name="mode" value="<?php echo $mode; ?>" />
<input type="hidden" name="env" value="<?php echo $env; ?>" />
<input type="hidden" name="dir" value="<?php echo $current_dir; ?>" /></p><p>
<input class="submit" type="submit" value="<?php echo  __('Add the file'); ?>" /></p>
</fieldset>
</form>
<?php endif; ?>

<h2><?php   echo __('Your files'); ?></h2>
<?php
/* Start populating the list of files and folders */
$img_list = array();
$rep_list = array();

if ($is_dir) {
	$D = dir($up_dir.'/'.$current_dir);
	$i = 0;
	$j = 0;
	//Get the parent folder to go "up" one level.
	if (strlen($current_dir) > 0) {
		$parent_dir = getParentDir($current_dir);
		if (empty($parent_dir)) $parent_dir = '/';
		$rep_list[$j]['url'] = $_PX_website_config['rel_url_files'].'/'.$parent_dir;
		$rep_list[$j]['name'] = __('Parent folder');
		$rep_list[$j]['current_dir'] = $parent_dir;
		$rep_list[$j]['type'] = 'updir';
		$j++;
	}
	while(false !== ($entry = $D->read()))
	{
		if($entry != '.' && $entry != '..' && $entry != '.htaccess' && $entry != '.htpasswd') {
			if (!is_dir($up_dir.'/'.$current_dir.$entry)) {
				$img_list[$i]['url'] = $_PX_website_config['rel_url_files'].'/'.$current_dir.$entry;
				$img_list[$i]['name'] = $entry;
				$img_list[$i]['current_dir'] = $current_dir;
				$img_list[$i]['type'] = 'file';
				$i++;
			} elseif ($entry != 'thumb') {
				$rep_list[$j]['url'] = $_PX_website_config['rel_url_files'].'/'.$current_dir.$entry;
				$rep_list[$j]['name'] = $entry;
				$rep_list[$j]['current_dir'] = $current_dir.$entry;
				$rep_list[$j]['type'] = 'dir';
				$j++;
			}
		}
	}
	$D->close();
}
/* End populating the list of files and folders */

/* Line to display a file */
function line_file($data,$i)
{
	global $mode, $up_dir, $_PX_website_config, $m, $px_gd_version, $env, $_px_theme;

	// 4 kinds of entry: "up" folder, folder, image and normal file
	// 2 modes: popup and normal
	$is_dir = false;
	$is_file = false;
	$is_image = false;
	$is_updir = false;
	$url = $data['url'];
	$name = $data['name'];
	$current_dir = $data['current_dir'];

	switch ($data['type']) {
	case 'file':
		$is_image = isImage($name);
		$is_file = !$is_image;
		$ext = getFileExtension($name);
		break;
	case 'dir':
		$is_dir = true;
		break;
	case 'updir':
		$is_updir = true;
		break;
	}

	$res = ''; //final string to be displayed.
	$file_size = ''; //contains the height/width of the image or the size of the file, nothing
					// if an image and impossible to get the size
	$create_thumb = ''; //link to create the thumbnail
	$icons_dir = $GLOBALS['_PX_config']['manager_path'] . '/themes/'.$_px_theme.'/images/icons/';

	$delete_link = '<a href="xmedia.php?dir='.rawurlencode($current_dir).'&amp;file='.rawurlencode($current_dir.$name).'&amp;del=1&amp;mode='.$mode.'&amp;env='.$env.'" '.
			'title="'. __('Delete').'" onclick="return window.confirm(\''. __('Are you sure you want to delete this file?').'\')"><img src="themes/'.$_px_theme.'/images/delete.png" alt="'. __('Delete').'" /></a>';



	// Get size of the file in $file_size format ready to be displayed
	if ($is_image) {
		$siz = @getimagesize($_PX_website_config['xmedia_root'].'/'.$current_dir.$name);
		if ($siz !== false && 'html' == $m->user->getPref('content_format')) {
			//HTML format
			$file_size = __('<strong>size</strong>:') .' '.$siz[3];
		} elseif ($siz !== false) {
			//wiki format
			$file_size = __('<strong>size</strong>:') .' '.$siz[0].'x'.$siz[1];
		}
	} elseif ($is_file) {
		//size in kb
		$file_size =  __('<strong>size</strong>:') .' '.prettySize(filesize($_PX_website_config['xmedia_root'].'/'.$current_dir.$name));
	}

	if ($mode == 'popup' && ($is_image || $is_file)) {
		//call from the popup
		$act = ($is_image) ? 'img' : 'file';
		$action_link = '<a href="#" '.
		'onclick="insertImage(window.opener.document,\''.$url.'\',\''.$act.'\',\''.addslashes( __('Title of the file or image:')).'\'); '.
		'window.close(); return false;">%s</a>';
	} elseif ($is_dir || $is_updir) {
	    $slash = ($is_dir) ? '/' : '';
		$action_link = '<a href="xmedia.php?dir='.$current_dir.$slash.'&amp;mode='.$mode.'">%s</a>';
	} else {
		//call from the "normal" list of files page
		$action_link = '<a href="http://'.$_PX_website_config['domain'].$url.'">%s</a>';
	}

	// create the thumbnail link
	if ($is_file || $is_image) {
		if (file_exists($up_dir.'/thumb/'.md5($current_dir.$name).'.jpg')) {
			//thumbnail exists
			$th = sprintf($action_link,
				'<img class="thumbnail" '.
				'src="http://'.$_PX_website_config['domain'].$_PX_website_config['rel_url_files'].'/thumb/'.md5($current_dir.$name).'.jpg" alt="" />');
		} elseif ($is_image && $px_gd_version) {
			//image without thumbnail
			if (file_exists($icons_dir.$ext.'-dist.png')) {
				$img = 'themes/'.$_px_theme.'/images/icons/'.$ext.'-dist.png';
			} else {
				$img = 'themes/'.$_px_theme.'/images/icons/default-dist.png';
			}
			$th = sprintf($action_link, '<img class="thumbnailicon" src="'.$img.'" alt="" />');
			$create_thumb = '<a href="xmedia.php?dir='.rawurlencode($current_dir).'&amp;file='.rawurlencode($current_dir.$name).
			'&amp;thumb=1&amp;mode='.$mode.'&amp;env='.$env.'" title="'.__('Try to create the thumbnail').'"><img src="themes/'.$_px_theme.'/images/ico_createthumb.png" alt="'.__('Try to create the thumbnail').'" /></a>';
		} else {
			//normal file
			$ext = getFileExtension($name);
			if (file_exists($icons_dir.$ext.'-dist.png')) {
				$img = 'themes/'.$_px_theme.'/images/icons/'.$ext.'-dist.png';
			} else {
				$img = 'themes/'.$_px_theme.'/images/icons/default-dist.png';
			}
			$th = sprintf($action_link, '<img class="thumbnailicon" src="'.$img.'" alt="" />');
		}
		$res = '<div class="icon">'."\n".
			'<p class="legend action">'.$create_thumb.' '.$delete_link.'</p>'."\n".
			'<p class="icon">'.$th.'</p>'."\n".
			'<p class="legend">'.sprintf($action_link,$name).'<br />'."\n".
			$file_size.'</p>'."\n".
			'</div>'."\n";
	} elseif ($is_dir || $is_updir) {
		$ico = ($is_dir) ? 'ico_folder.png' : 'ico_folder_up.png';
		$img = 'themes/'.$_px_theme.'/images/'.$ico;
		$th = sprintf($action_link, '<img class="thumbnailicon" src="'.$img.'" alt="" />');
			$res = '<div class="icon">'."\n".
			'<p class="icon">'.$th.'</p>'."\n".
			'<p class="legend">'.sprintf($action_link,$name).'</p>'."\n".
			'</div>'."\n";
	}


	return $res;
}

// Display the files and folders
$img_list = array_merge($rep_list, $img_list);

$objLum = new lum($env, 'line_file', $img_list, 0, 12);
$m->user->savePref('xmedia_current_page', $objLum->env, $_SESSION['website_id'], true);
$objLum->htmlHeader = '<div class="spacer"> &nbsp; </div>';
$objLum->htmlLineStart = '';
$objLum->htmlColStart = '';
$objLum->htmlColEnd = '';
$objLum->htmlLineEnd = '';
$objLum->htmlFooter = '<div class="spacer"> &nbsp; </div>';

$objLum->htmlLinksStart = '<p class="small">';
$objLum->htmlLinksEnd = '</p>';

$objLum->htmlCurPgStart = '<strong>';
$objLum->htmlCurPgEnd = '</strong>';

$objLum->htmlPrev =  __('&laquo; previous page');
$objLum->htmlNext =  __('&raquo; next page');
$objLum->htmlPrevGrp = '...';
$objLum->htmlNextGrp = '...';

$objLum->htmlEmpty = '<div class="spacer"> &nbsp; </div><div class="icon"><p class="icon"><strong>'. __('No file for the moment.').'</strong></p></div><div class="spacer"> &nbsp; </div>';
$objLum->htmlLinksLib =  __('page(s):');

if ($is_dir) {
	$parent_dir = getParentDir($current_dir);
	if (empty($parent_dir)) $parent_dir = '/';

	echo '<p class="small">';
	if (strlen($current_dir) > 0) {
		echo '<a href="xmedia.php?dir='.$parent_dir.'&amp;mode='.$mode.'" title="'.__('Go one folder up.').'"><img src="themes/'.$_px_theme.'/images/ico_folder_up_small.png" alt=" " /></a> ';
	}
	echo sprintf( __('You are in the folder <strong>%s</strong>'), $_PX_website_config['rel_url_files'].'/'.$current_dir);
	echo '</p>';

	echo $objLum->drawLinks()."\n\n";
	echo $objLum->drawPage()."\n\n";
	echo $objLum->drawLinks()."\n\n";

	echo '<p class="small">';
	if (strlen($current_dir) > 0) {
		echo '<a href="xmedia.php?dir='.$parent_dir.'&amp;mode='.$mode.'" title="'.__('Go one folder up.').'"><img src="themes/'.$_px_theme.'/images/ico_folder_up_small.png" alt=" " /></a> ';
	}
	echo sprintf( __('You are in the folder <strong>%s</strong>'), $_PX_website_config['rel_url_files'].'/'.$current_dir);

	if (count($rep_list) == 0 && count($img_list) == 0 && $is_writable &&  (false === $m->error())
		&& (authAsLevel(PX_AUTH_ADVANCED, (isset($_SESSION['website_id']))?$_SESSION['website_id']:''))) {

		echo ' <strong><a href="xmedia.php?dir='.rawurlencode($current_dir).'&amp;delfolder=1&amp;mode='.$mode.'" '.
		'onclick="return window.confirm(\''. __('Are you sure you want to delete this folder?').'\')" title="'. __('Delete this folder').'"><img src="themes/'.$_px_theme.'/images/delete.png" alt=" " /></a></strong>';
	}
	echo '</p>';

	if ($is_writable &&  (false === $m->error())
		&& (authAsLevel(PX_AUTH_ADVANCED, (isset($_SESSION['website_id']))?$_SESSION['website_id']:'')) ) {
		?><form action='xmedia.php' method='POST'>
		<input type='hidden' name='dir' value='<?php echo $current_dir; ?>' />
		<input type='hidden' name='mode' value='<?php echo $mode; ?>' />
		<p>
		<span class="nowrap"><label for="new_folder"
		style="display:inline"><?php  echo __('Create a sub-folder'); ?> <?php $m->HelpLink('xmedia', 'h-sub-folder'); ?></label>
		<?php echo php_f_textField('new_folder', 15, 30, '', '', ''); ?>
		<input name="create" type="submit" class="submit" value="<?php  echo __('Create'); ?>" />
		</span></p>
		</form>
		<?php

	}
}

?>


<?php
if ($mode == 'popup') {
	include dirname(__FILE__).'/mtemplates/_pop_bottom.php';
} else {
	include dirname(__FILE__).'/mtemplates/_bottom.php';
}
?>
